using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using TMPro;
using UnityEngine;
using UnityEngine.Events;
using UnityEngine.UI;
using System.Reflection;
using System.IO;
using UnityEngine.SceneManagement;
using System.Reflection;
using System.Collections;
using System.Threading.Tasks;
using System.Linq;

namespace Mod
{
    public class Mod
    {
        public static Sprite skull1 = ModAPI.LoadSprite("eye.png");
        public static Sprite skull2 = ModAPI.LoadSprite("jaw.png");
        public static Sprite skull3 = ModAPI.LoadSprite("skull.png");
        public static Sprite eyeball = ModAPI.LoadSprite("eyes.png");
        public static Sprite brian = ModAPI.LoadSprite("brian.png");
        public static Sprite rib1 = ModAPI.LoadSprite("rib1.png");
        public static Sprite rib2 = ModAPI.LoadSprite("rib2.png");
        public static Sprite rib3 = ModAPI.LoadSprite("rib3.png");
        public static Sprite peter = ModAPI.LoadSprite("peter.png");
        public static AudioClip beat = ModAPI.LoadSound("beat.wav");
        public static Sprite stewie = ModAPI.LoadSprite("stewie.png");
        public static Sprite lung = ModAPI.LoadSprite("lung.png");
        public static Sprite chunk = ModAPI.LoadSprite("chunk.png");
        public static Sprite liver1 = ModAPI.LoadSprite("liver1.png");
        public static Sprite liver2 = ModAPI.LoadSprite("liver2.png");
        public static Sprite liver3 = ModAPI.LoadSprite("liver3.png");
        public static Sprite joe1 = ModAPI.LoadSprite("joe1.png");
        public static Sprite joe2 = ModAPI.LoadSprite("joe2.png");
        public static Sprite joe3 = ModAPI.LoadSprite("joe3.png");
        public static Sprite mid1 = ModAPI.LoadSprite("mid1.png");
        public static Sprite mid2 = ModAPI.LoadSprite("mid2.png");
        public static Sprite mid3 = ModAPI.LoadSprite("mid3.png");
        public static Sprite frag1 = ModAPI.LoadSprite("frag1.png");
        public static Sprite frag2 = ModAPI.LoadSprite("frag2.png");
        public static Sprite frag3 = ModAPI.LoadSprite("frag3.png");

        public static void OnLoad()
        {
            if (!Directory.Exists(@"Mods\\zuccian\\gore"))
            {
                Directory.CreateDirectory(@"Mods\\zuccian\\gore");
                DialogBox inv = (DialogBox)null;
                inv = DialogBoxManager.Dialog("thank you for installing this mod\n if your interested in more like it, consider joining my discord or supporting me on patreon", new DialogButton[]
                {
                    new DialogButton("discord", false, () =>
                    {
                        Utility.OpenLink("https://discord.gg/zuccian");
                    }),
                    new DialogButton("patreon", false, () =>
                    {
                        Utility.OpenLink("https://www.patreon.com/zuccian/membership");
                    }),
                    new DialogButton("no thank you", true, () => DialogBoxManager.Notification("enjoy the mod"))
                });
            }
        }

        public static void Main()
        {
            ModAPI.OnItemSpawned += (sender, obj) =>
            {
                GameObject gameObject = obj.Instance;
                if (gameObject.transform.root.gameObject.GetComponent<PersonBehaviour>())
                {
                    gameObject.transform.root.gameObject.GetComponent<PersonBehaviour>().Limbs[0].gameObject.AddComponent<BrainSplatter>();
                    gameObject.transform.root.gameObject.GetComponent<PersonBehaviour>().Limbs[1].gameObject.AddComponent<ChestSplatter>();
                    gameObject.transform.root.gameObject.GetComponent<PersonBehaviour>().Limbs[2].gameObject.AddComponent<MiddleSplatter>();
                    gameObject.transform.root.gameObject.GetComponent<PersonBehaviour>().Limbs[3].gameObject.AddComponent<LowerSplatter>();

                    gameObject.transform.root.gameObject.GetComponent<PersonBehaviour>().Limbs[4].gameObject.AddComponent<OtherSplatter>();
                    gameObject.transform.root.gameObject.GetComponent<PersonBehaviour>().Limbs[5].gameObject.AddComponent<OtherSplatter>();
                    gameObject.transform.root.gameObject.GetComponent<PersonBehaviour>().Limbs[6].gameObject.AddComponent<OtherSplatter>();
                    gameObject.transform.root.gameObject.GetComponent<PersonBehaviour>().Limbs[7].gameObject.AddComponent<OtherSplatter>();
                    gameObject.transform.root.gameObject.GetComponent<PersonBehaviour>().Limbs[8].gameObject.AddComponent<OtherSplatter>();
                    gameObject.transform.root.gameObject.GetComponent<PersonBehaviour>().Limbs[9].gameObject.AddComponent<OtherSplatter>();
                    gameObject.transform.root.gameObject.GetComponent<PersonBehaviour>().Limbs[10].gameObject.AddComponent<OtherSplatter>();
                    gameObject.transform.root.gameObject.GetComponent<PersonBehaviour>().Limbs[11].gameObject.AddComponent<OtherSplatter>();
                    gameObject.transform.root.gameObject.GetComponent<PersonBehaviour>().Limbs[12].gameObject.AddComponent<OtherSplatter>();
                    gameObject.transform.root.gameObject.GetComponent<PersonBehaviour>().Limbs[13].gameObject.AddComponent<OtherSplatter>();
                }
            };
            ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Insulator"),
        NameOverride = "spineobject",
        DescriptionOverride = " ", 
        CategoryOverride = ModAPI.FindCategory(" "), 
        ThumbnailOverride = ModAPI.LoadSprite("spine.png"), 
        AfterSpawn = (Instance) => 
        {
            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("spine.png");
            Instance.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Brick");
            
            Instance.layer = 9;
            Instance.FixColliders();

                              var chain = new GameObject("chain");
                              chain = GameObject.Instantiate(ModAPI.FindSpawnable("Insulator").Prefab);
                                          chain.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Brick");

                              SpriteRenderer chainRenderer = chain.GetComponent<SpriteRenderer>();
                                          chainRenderer.sprite = ModAPI.LoadSprite("spine.png", 1f);
                                          chainRenderer.sortingLayerName = "Middle";
                                          foreach (var c in chain.GetComponents<Collider2D>())
                                          {
                                              GameObject.Destroy(c);
                                          }
                                          chain.AddComponent<CircleCollider2D>();
			    chain.transform.SetParent(Instance.transform);
                                          chain.transform.localScale = new Vector3(1f, 1f);


                                   HingeJoint2D hingeJoint = chain.GetOrAddComponent<HingeJoint2D>();
                                   hingeJoint.connectedBody = Instance.GetComponent<Rigidbody2D>();
                                   hingeJoint.anchor = new Vector3(0f, 0f);

                                   JointAngleLimits2D limits = hingeJoint.limits;
                                   limits.min = 700;
                                   limits.max = -700;
                                   hingeJoint.limits = limits;
                                   hingeJoint.useLimits = false;

                            chain.gameObject.layer = 9;


                                   chain.transform.localPosition = new Vector3(0f, 0.1f);//0f, 0.2f


                       var chain2 = new GameObject("chain2");
                       chain2 = GameObject.Instantiate(ModAPI.FindSpawnable("Insulator").Prefab);
                                   chain2.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Brick");

                                   SpriteRenderer chain2Renderer = chain2.GetComponent<SpriteRenderer>();
                                   chain2Renderer.sprite = ModAPI.LoadSprite("spine.png", 1f);
                                   chain2Renderer.sortingLayerName = "Bottom";
                                   foreach (var c in chain2.GetComponents<Collider2D>())
                                   {
                                       GameObject.Destroy(c);
                                   }
chain2.GetComponent<Rigidbody2D>();
                                   chain2.AddComponent<BoxCollider2D>();
			    chain2.transform.SetParent(chain.gameObject.transform);
                                   chain2.transform.localPosition = chain.transform.localPosition;
                                   chain2.transform.localScale = new Vector3(1f, 1f);

                                   HingeJoint2D chain2hingeJoint = chain2.GetOrAddComponent<HingeJoint2D>();
                                   chain2hingeJoint.connectedBody = chain.gameObject.GetComponent<Rigidbody2D>();
                                   chain2hingeJoint.anchor = new Vector3(0f, 0f);

                                   JointAngleLimits2D chain2limits = hingeJoint.limits;
                                   chain2limits.min = 700;
                                   chain2limits.max = -700;
                                   chain2hingeJoint.limits = chain2limits;
                                   chain2hingeJoint.useLimits = false;

                                   chain2.transform.localPosition = new Vector3(0f, 0.1f);//0f, 0.2f

                            chain2.gameObject.layer = 9;


                       var chain3 = new GameObject("chain3");
                       chain3 = GameObject.Instantiate(ModAPI.FindSpawnable("Insulator").Prefab);
                                   chain3.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Brick");

                                   SpriteRenderer chain3Renderer = chain3.GetComponent<SpriteRenderer>();
                                   chain3Renderer.sprite = ModAPI.LoadSprite("spine.png", 1f);
                                   chain3Renderer.sortingLayerName = "Bottom";
                                   foreach (var c in chain3.GetComponents<Collider2D>())
                                   {
                                       GameObject.Destroy(c);
                                   }
chain3.GetComponent<Rigidbody2D>();
                                   chain3.AddComponent<BoxCollider2D>();
			    chain3.transform.SetParent(chain2.gameObject.transform);
                                   chain3.transform.localPosition = chain2.transform.localPosition;
                                   chain3.transform.localScale = new Vector3(1f, 1f);

                                   HingeJoint2D chain3hingeJoint = chain3.GetOrAddComponent<HingeJoint2D>();
                                   chain3hingeJoint.connectedBody = chain2.gameObject.GetComponent<Rigidbody2D>();
                                   chain3hingeJoint.anchor = new Vector3(0f, 0f);

                                   JointAngleLimits2D chain3limits = hingeJoint.limits;
                                   chain3limits.min = 700;
                                   chain3limits.max = -700;
                                   chain3hingeJoint.limits = chain3limits;
                                   chain3hingeJoint.useLimits = false;

                                   chain3.transform.localPosition = new Vector3(0f, 0.1f);//0f, 0.2f

                            chain3.gameObject.layer = 9;


                       var chain4 = new GameObject("chain4");
                       chain4 = GameObject.Instantiate(ModAPI.FindSpawnable("Insulator").Prefab);
                                   chain4.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Brick");

                                   SpriteRenderer chain4Renderer = chain4.GetComponent<SpriteRenderer>();
                                   chain4Renderer.sprite = ModAPI.LoadSprite("spine.png", 1f);
                                   chain4Renderer.sortingLayerName = "Bottom";
                                   foreach (var c in chain4.GetComponents<Collider2D>())
                                   {
                                       GameObject.Destroy(c);
                                   }
chain4.GetComponent<Rigidbody2D>();
                                   chain4.AddComponent<BoxCollider2D>();
			    chain4.transform.SetParent(chain3.gameObject.transform);
                                   chain4.transform.localPosition = chain3.transform.localPosition;
                                   chain4.transform.localScale = new Vector3(1f, 1f);

                                   HingeJoint2D chain4hingeJoint = chain4.GetOrAddComponent<HingeJoint2D>();
                                   chain4hingeJoint.connectedBody = chain3.gameObject.GetComponent<Rigidbody2D>();
                                   chain4hingeJoint.anchor = new Vector3(0f, 0f);

                                   JointAngleLimits2D chain4limits = hingeJoint.limits;
                                   chain4limits.min = 700;
                                   chain4limits.max = -700;
                                   chain4hingeJoint.limits = chain4limits;
                                   chain4hingeJoint.useLimits = false;

                                   chain4.transform.localPosition = new Vector3(0f, 0.1f);//0f, 0.2f

                            chain4.gameObject.layer = 9;


                       var chain5 = new GameObject("chain5");
                       chain5 = GameObject.Instantiate(ModAPI.FindSpawnable("Insulator").Prefab);
                                   chain5.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Brick");

                                   SpriteRenderer chain5Renderer = chain5.GetComponent<SpriteRenderer>();
                                   chain5Renderer.sprite = ModAPI.LoadSprite("spine.png", 1f);
                                   chain5Renderer.sortingLayerName = "Bottom";
                                   foreach (var c in chain5.GetComponents<Collider2D>())
                                   {
                                       GameObject.Destroy(c);
                                   }
chain5.GetComponent<Rigidbody2D>();
                                   chain5.AddComponent<BoxCollider2D>();
			    chain5.transform.SetParent(chain4.gameObject.transform);
                                   chain5.transform.localPosition = chain4.transform.localPosition;
                                   chain5.transform.localScale = new Vector3(1f, 1f);

                                   HingeJoint2D chain5hingeJoint = chain5.GetOrAddComponent<HingeJoint2D>();
                                   chain5hingeJoint.connectedBody = chain4.gameObject.GetComponent<Rigidbody2D>();
                                   chain5hingeJoint.anchor = new Vector3(0f, 0f);

                                   JointAngleLimits2D chain5limits = hingeJoint.limits;
                                   chain5limits.min = 700;
                                   chain5limits.max = -700;
                                   chain5hingeJoint.limits = chain5limits;
                                   chain5hingeJoint.useLimits = false;

                                   chain5.transform.localPosition = new Vector3(0f, 0.1f);//0f, 0.2f

                            chain5.gameObject.layer = 9;


                       var chain6 = new GameObject("chain6");
                       chain6 = GameObject.Instantiate(ModAPI.FindSpawnable("Insulator").Prefab);
                                   chain6.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Brick");

                                   SpriteRenderer chain6Renderer = chain6.GetComponent<SpriteRenderer>();
                                   chain6Renderer.sprite = ModAPI.LoadSprite("spine.png", 1f);
                                   chain6Renderer.sortingLayerName = "Bottom";
                                   foreach (var c in chain6.GetComponents<Collider2D>())
                                   {
                                       GameObject.Destroy(c);
                                   }
chain6.GetComponent<Rigidbody2D>();
                                   chain6.AddComponent<BoxCollider2D>();
			    chain6.transform.SetParent(chain5.gameObject.transform);
                                   chain6.transform.localPosition = chain5.transform.localPosition;
                                   chain6.transform.localScale = new Vector3(1f, 1f);

                                   HingeJoint2D chain6hingeJoint = chain6.GetOrAddComponent<HingeJoint2D>();
                                   chain6hingeJoint.connectedBody = chain5.gameObject.GetComponent<Rigidbody2D>();
                                   chain6hingeJoint.anchor = new Vector3(0f, 0f);

                                   JointAngleLimits2D chain6limits = hingeJoint.limits;
                                   chain6limits.min = 700;
                                   chain6limits.max = -700;
                                   chain6hingeJoint.limits = chain5limits;
                                   chain6hingeJoint.useLimits = false;

                                   chain6.transform.localPosition = new Vector3(0f, 0.1f);//0f, 0.2f

                            chain6.gameObject.layer = 9;


                       var chain7 = new GameObject("chain7");
                       chain7 = GameObject.Instantiate(ModAPI.FindSpawnable("Insulator").Prefab);
                                   chain7.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Brick");

                                   SpriteRenderer chain7Renderer = chain7.GetComponent<SpriteRenderer>();
                                   chain7Renderer.sprite = ModAPI.LoadSprite("spine.png", 1f);
                                   chain7Renderer.sortingLayerName = "Bottom";
                                   foreach (var c in chain7.GetComponents<Collider2D>())
                                   {
                                       GameObject.Destroy(c);
                                   }
chain7.GetComponent<Rigidbody2D>();
                                   chain7.AddComponent<BoxCollider2D>();
			    chain7.transform.SetParent(chain6.gameObject.transform);
                                   chain7.transform.localPosition = chain6.transform.localPosition;
                                   chain7.transform.localScale = new Vector3(1f, 1f);

                                   HingeJoint2D chain7hingeJoint = chain7.GetOrAddComponent<HingeJoint2D>();
                                   chain7hingeJoint.connectedBody = chain6.gameObject.GetComponent<Rigidbody2D>();
                                   chain7hingeJoint.anchor = new Vector3(0f, 0f);

                                   JointAngleLimits2D chain7limits = hingeJoint.limits;
                                   chain7limits.min = 700;
                                   chain7limits.max = -700;
                                   chain7hingeJoint.limits = chain5limits;
                                   chain7hingeJoint.useLimits = false;

                                   chain7.transform.localPosition = new Vector3(0f, 0.1f);//0f, 0.2f

                            chain7.gameObject.layer = 9;


                       var chain8 = new GameObject("chain8");
                       chain8 = GameObject.Instantiate(ModAPI.FindSpawnable("Insulator").Prefab);
                                   chain8.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Brick");

                                   SpriteRenderer chain8Renderer = chain8.GetComponent<SpriteRenderer>();
                                   chain8Renderer.sprite = ModAPI.LoadSprite("spine.png", 1f);
                                   chain8Renderer.sortingLayerName = "Bottom";
                                   foreach (var c in chain8.GetComponents<Collider2D>())
                                   {
                                       GameObject.Destroy(c);
                                   }
chain8.GetComponent<Rigidbody2D>();
                                   chain8.AddComponent<BoxCollider2D>();
			    chain8.transform.SetParent(chain7.gameObject.transform);
                                   chain8.transform.localPosition = chain7.transform.localPosition;
                                   chain8.transform.localScale = new Vector3(1f, 1f);

                                   HingeJoint2D chain8hingeJoint = chain8.GetOrAddComponent<HingeJoint2D>();
                                   chain8hingeJoint.connectedBody = chain7.gameObject.GetComponent<Rigidbody2D>();
                                   chain8hingeJoint.anchor = new Vector3(0f, 0f);

                                   JointAngleLimits2D chain8limits = hingeJoint.limits;
                                   chain8limits.min = 700;
                                   chain8limits.max = -700;
                                   chain8hingeJoint.limits = chain5limits;
                                   chain8hingeJoint.useLimits = false;

                                   chain8.transform.localPosition = new Vector3(0f, 0.1f);//0f, 0.2f

                            chain8.gameObject.layer = 9;


                       var chain9 = new GameObject("chain9");
                       chain9 = GameObject.Instantiate(ModAPI.FindSpawnable("Insulator").Prefab);
                                   chain9.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Brick");

                                   SpriteRenderer chain9Renderer = chain9.GetComponent<SpriteRenderer>();
                                   chain9Renderer.sprite = ModAPI.LoadSprite("spine.png", 1f);
                                   chain9Renderer.sortingLayerName = "Bottom";
                                   foreach (var c in chain9.GetComponents<Collider2D>())
                                   {
                                       GameObject.Destroy(c);
                                   }
chain9.GetComponent<Rigidbody2D>();
                                   chain9.AddComponent<BoxCollider2D>();
			    chain9.transform.SetParent(chain8.gameObject.transform);
                                   chain9.transform.localPosition = chain8.transform.localPosition;
                                   chain9.transform.localScale = new Vector3(1f, 1f);

                                   HingeJoint2D chain9hingeJoint = chain9.GetOrAddComponent<HingeJoint2D>();
                                   chain9hingeJoint.connectedBody = chain8.gameObject.GetComponent<Rigidbody2D>();
                                   chain9hingeJoint.anchor = new Vector3(0f, 0f);

                                   JointAngleLimits2D chain9limits = hingeJoint.limits;
                                   chain9limits.min = 700;
                                   chain9limits.max = -700;
                                   chain9hingeJoint.limits = chain5limits;
                                   chain9hingeJoint.useLimits = false;

                                   chain9.transform.localPosition = new Vector3(0f, 0.1f);//0f, 0.2f

                            chain9.gameObject.layer = 9;
 

                       var chain11 = new GameObject("chain11");
                       chain11 = GameObject.Instantiate(ModAPI.FindSpawnable("Insulator").Prefab);
                                   chain11.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Brick");

                                   SpriteRenderer chain11Renderer = chain11.GetComponent<SpriteRenderer>();
                                   chain11Renderer.sprite = ModAPI.LoadSprite("spine.png", 1f);
                                   chain11Renderer.sortingLayerName = "Bottom";
                                   foreach (var c in chain11.GetComponents<Collider2D>())
                                   {
                                       GameObject.Destroy(c);
                                   }
chain11.GetComponent<Rigidbody2D>();
                                   chain11.AddComponent<BoxCollider2D>();
			    chain11.transform.SetParent(chain9.gameObject.transform);
                                   chain11.transform.localPosition = chain9.transform.localPosition;
                                   chain11.transform.localScale = new Vector3(1f, 1f);

                                   HingeJoint2D chain11hingeJoint = chain11.GetOrAddComponent<HingeJoint2D>();
                                   chain11hingeJoint.connectedBody = chain9.gameObject.GetComponent<Rigidbody2D>();
                                   chain11hingeJoint.anchor = new Vector3(0f, 0f);

                                   JointAngleLimits2D chain11limits = hingeJoint.limits;
                                   chain11limits.min = 700;
                                   chain11limits.max = -700;
                                   chain11hingeJoint.limits = chain5limits;
                                   chain11hingeJoint.useLimits = false;

                                   chain11.transform.localPosition = new Vector3(0f, 0.1f);//0f, 0.2f

                            chain11.gameObject.layer = 9;


                       var chain12 = new GameObject("chain12");
                       chain12 = GameObject.Instantiate(ModAPI.FindSpawnable("Insulator").Prefab);
                                   chain12.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Brick");

                                   SpriteRenderer chain12Renderer = chain12.GetComponent<SpriteRenderer>();
                                   chain12Renderer.sprite = ModAPI.LoadSprite("spine.png", 1f);
                                   chain12Renderer.sortingLayerName = "Bottom";
                                   foreach (var c in chain12.GetComponents<Collider2D>())
                                   {
                                       GameObject.Destroy(c);
                                   }
chain12.GetComponent<Rigidbody2D>();
                                   chain12.AddComponent<BoxCollider2D>();
			    chain12.transform.SetParent(chain11.gameObject.transform);
                                   chain12.transform.localPosition = chain11.transform.localPosition;
                                   chain12.transform.localScale = new Vector3(1f, 1f);

                                   HingeJoint2D chain12hingeJoint = chain12.GetOrAddComponent<HingeJoint2D>();
                                   chain12hingeJoint.connectedBody = chain11.gameObject.GetComponent<Rigidbody2D>();
                                   chain12hingeJoint.anchor = new Vector3(0f, 0f);

                                   JointAngleLimits2D chain12limits = hingeJoint.limits;
                                   chain12limits.min = 700;
                                   chain12limits.max = -700;
                                   chain12hingeJoint.limits = chain5limits;
                                   chain12hingeJoint.useLimits = false;

                                   chain12.transform.localPosition = new Vector3(0f, 0.1f);//0f, 0.2f

                            chain12.gameObject.layer = 9;


                       var chain13 = new GameObject("chain13");
                       chain13 = GameObject.Instantiate(ModAPI.FindSpawnable("Insulator").Prefab);
                                   chain13.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Brick");

                                   SpriteRenderer chain13Renderer = chain13.GetComponent<SpriteRenderer>();
                                   chain13Renderer.sprite = ModAPI.LoadSprite("spine.png", 1f);
                                   chain13Renderer.sortingLayerName = "Bottom";
                                   foreach (var c in chain13.GetComponents<Collider2D>())
                                   {
                                       GameObject.Destroy(c);
                                   }
chain13.GetComponent<Rigidbody2D>();
                                   chain13.AddComponent<BoxCollider2D>();
			    chain13.transform.SetParent(chain12.gameObject.transform);
                                   chain13.transform.localPosition = chain12.transform.localPosition;
                                   chain13.transform.localScale = new Vector3(1f, 1f);

                                   HingeJoint2D chain13hingeJoint = chain13.GetOrAddComponent<HingeJoint2D>();
                                   chain13hingeJoint.connectedBody = chain12.gameObject.GetComponent<Rigidbody2D>();
                                   chain13hingeJoint.anchor = new Vector3(0f, 0f);

                                   JointAngleLimits2D chain13limits = hingeJoint.limits;
                                   chain13limits.min = 700;
                                   chain13limits.max = -700;
                                   chain13hingeJoint.limits = chain5limits;
                                   chain13hingeJoint.useLimits = false;

                                   chain13.transform.localPosition = new Vector3(0f, 0.1f);//0f, 0.2f

                            chain13.gameObject.layer = 9;


                       var chain14 = new GameObject("chain14");
                       chain14 = GameObject.Instantiate(ModAPI.FindSpawnable("Insulator").Prefab);
                                   chain14.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Brick");

                                   SpriteRenderer chain14Renderer = chain14.GetComponent<SpriteRenderer>();
                                   chain14Renderer.sprite = ModAPI.LoadSprite("spine.png", 1f);
                                   chain14Renderer.sortingLayerName = "Bottom";
                                   foreach (var c in chain14.GetComponents<Collider2D>())
                                   {
                                       GameObject.Destroy(c);
                                   }
chain14.GetComponent<Rigidbody2D>();
                                   chain14.AddComponent<BoxCollider2D>();
			    chain14.transform.SetParent(chain13.gameObject.transform);
                                   chain14.transform.localPosition = chain13.transform.localPosition;
                                   chain14.transform.localScale = new Vector3(1f, 1f);

                                   HingeJoint2D chain14hingeJoint = chain14.GetOrAddComponent<HingeJoint2D>();
                                   chain14hingeJoint.connectedBody = chain13.gameObject.GetComponent<Rigidbody2D>();
                                   chain14hingeJoint.anchor = new Vector3(0f, 0f);

                                   JointAngleLimits2D chain14limits = hingeJoint.limits;
                                   chain14limits.min = 700;
                                   chain14limits.max = -700;
                                   chain14hingeJoint.limits = chain5limits;
                                   chain14hingeJoint.useLimits = false;

                                   chain14.transform.localPosition = new Vector3(0f, 0.1f);//0f, 0.2f

                            chain14.gameObject.layer = 9;


                       var chain15 = new GameObject("chain15");
                       chain15 = GameObject.Instantiate(ModAPI.FindSpawnable("Insulator").Prefab);
                                   chain15.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Brick");

                                   SpriteRenderer chain15Renderer = chain15.GetComponent<SpriteRenderer>();
                                   chain15Renderer.sprite = ModAPI.LoadSprite("spine.png", 1f);
                                   chain15Renderer.sortingLayerName = "Bottom";
                                   foreach (var c in chain15.GetComponents<Collider2D>())
                                   {
                                       GameObject.Destroy(c);
                                   }
chain15.GetComponent<Rigidbody2D>();
                                   chain15.AddComponent<BoxCollider2D>();
			    chain15.transform.SetParent(chain14.gameObject.transform);
                                   chain15.transform.localPosition = chain14.transform.localPosition;
                                   chain15.transform.localScale = new Vector3(1f, 1f);

                                   HingeJoint2D chain15hingeJoint = chain15.GetOrAddComponent<HingeJoint2D>();
                                   chain15hingeJoint.connectedBody = chain14.gameObject.GetComponent<Rigidbody2D>();
                                   chain15hingeJoint.anchor = new Vector3(0f, 0f);

                                   JointAngleLimits2D chain15limits = hingeJoint.limits;
                                   chain15limits.min = 700;
                                   chain15limits.max = -700;
                                   chain15hingeJoint.limits = chain5limits;
                                   chain15hingeJoint.useLimits = false;

                                   chain15.transform.localPosition = new Vector3(0f, 0.1f);//0f, 0.2f

                            chain15.gameObject.layer = 9;

                       var chain16 = new GameObject("chain16");
                       chain16 = GameObject.Instantiate(ModAPI.FindSpawnable("Insulator").Prefab);
                                   chain16.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Brick");

                                   SpriteRenderer chain16Renderer = chain16.GetComponent<SpriteRenderer>();
                                   chain16Renderer.sprite = ModAPI.LoadSprite("spine.png", 1f);
                                   chain16Renderer.sortingLayerName = "Bottom";
                                   foreach (var c in chain16.GetComponents<Collider2D>())
                                   {
                                       GameObject.Destroy(c);
                                   }
chain16.GetComponent<Rigidbody2D>();
                                   chain16.AddComponent<BoxCollider2D>();
			    chain16.transform.SetParent(chain15.gameObject.transform);
                                   chain16.transform.localPosition = chain15.transform.localPosition;
                                   chain16.transform.localScale = new Vector3(1f, 1f);

                                   HingeJoint2D chain16hingeJoint = chain16.GetOrAddComponent<HingeJoint2D>();
                                   chain16hingeJoint.connectedBody = chain15.gameObject.GetComponent<Rigidbody2D>();
                                   chain16hingeJoint.anchor = new Vector3(0f, 0f);

                                   JointAngleLimits2D chain16limits = hingeJoint.limits;
                                   chain16limits.min = 700;
                                   chain16limits.max = -700;
                                   chain16hingeJoint.limits = chain5limits;
                                   chain16hingeJoint.useLimits = false;

                                   chain16.transform.localPosition = new Vector3(0f, 0.1f);//0f, 0.2f

        var phys = chain16.GetComponent<PhysicalBehaviour>();
        var prop = ModAPI.FindPhysicalProperties("Brick");
        phys.Properties = prop;

        var cols = Instance.GetComponentsInChildren<Collider2D>();
                        foreach (var col1 in cols)
                        {
                            foreach (var col2 in cols)
                            {
                                Physics2D.IgnoreCollision(col1, col2);
                            }
                        }

                           }
                        }
                      );
                      ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Insulator"),
        NameOverride = "lintestineobject",
        DescriptionOverride = " ", 
        CategoryOverride = ModAPI.FindCategory(" "), 
        ThumbnailOverride = ModAPI.LoadSprite("lintestine.png"), 
        AfterSpawn = (Instance) => 
        {
            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("lintestine.png");
            Instance.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Human");
            
            Instance.layer = 9;
            Instance.FixColliders();

                              var chain = new GameObject("chain");
                              chain = GameObject.Instantiate(ModAPI.FindSpawnable("Insulator").Prefab);
                                          chain.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Human");

                              SpriteRenderer chainRenderer = chain.GetComponent<SpriteRenderer>();
                                          chainRenderer.sprite = ModAPI.LoadSprite("lintestine.png", 1f);
                                          chainRenderer.sortingLayerName = "Middle";
                                          foreach (var c in chain.GetComponents<Collider2D>())
                                          {
                                              GameObject.Destroy(c);
                                          }
                                          chain.AddComponent<CircleCollider2D>();
			    chain.transform.SetParent(Instance.transform);
                                          chain.transform.localScale = new Vector3(1f, 1f);


                                   HingeJoint2D hingeJoint = chain.GetOrAddComponent<HingeJoint2D>();
                                   hingeJoint.connectedBody = Instance.GetComponent<Rigidbody2D>();
                                   hingeJoint.anchor = new Vector3(0f, 0f);

                                   JointAngleLimits2D limits = hingeJoint.limits;
                                   limits.min = 700;
                                   limits.max = -700;
                                   hingeJoint.limits = limits;
                                   hingeJoint.useLimits = false;

                            chain.gameObject.layer = 9;


                                   chain.transform.localPosition = new Vector3(0f, 0.1f);//0f, 0.2f


                       var chain2 = new GameObject("chain2");
                       chain2 = GameObject.Instantiate(ModAPI.FindSpawnable("Insulator").Prefab);
                                   chain2.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Human");

                                   SpriteRenderer chain2Renderer = chain2.GetComponent<SpriteRenderer>();
                                   chain2Renderer.sprite = ModAPI.LoadSprite("lintestine.png", 1f);
                                   chain2Renderer.sortingLayerName = "Bottom";
                                   foreach (var c in chain2.GetComponents<Collider2D>())
                                   {
                                       GameObject.Destroy(c);
                                   }
chain2.GetComponent<Rigidbody2D>();
                                   chain2.AddComponent<BoxCollider2D>();
			    chain2.transform.SetParent(chain.gameObject.transform);
                                   chain2.transform.localPosition = chain.transform.localPosition;
                                   chain2.transform.localScale = new Vector3(1f, 1f);

                                   HingeJoint2D chain2hingeJoint = chain2.GetOrAddComponent<HingeJoint2D>();
                                   chain2hingeJoint.connectedBody = chain.gameObject.GetComponent<Rigidbody2D>();
                                   chain2hingeJoint.anchor = new Vector3(0f, 0f);

                                   JointAngleLimits2D chain2limits = hingeJoint.limits;
                                   chain2limits.min = 700;
                                   chain2limits.max = -700;
                                   chain2hingeJoint.limits = chain2limits;
                                   chain2hingeJoint.useLimits = false;

                                   chain2.transform.localPosition = new Vector3(0f, 0.1f);//0f, 0.2f

                            chain2.gameObject.layer = 9;


                       var chain3 = new GameObject("chain3");
                       chain3 = GameObject.Instantiate(ModAPI.FindSpawnable("Insulator").Prefab);
                                   chain3.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Human");

                                   SpriteRenderer chain3Renderer = chain3.GetComponent<SpriteRenderer>();
                                   chain3Renderer.sprite = ModAPI.LoadSprite("lintestine.png", 1f);
                                   chain3Renderer.sortingLayerName = "Bottom";
                                   foreach (var c in chain3.GetComponents<Collider2D>())
                                   {
                                       GameObject.Destroy(c);
                                   }
chain3.GetComponent<Rigidbody2D>();
                                   chain3.AddComponent<BoxCollider2D>();
			    chain3.transform.SetParent(chain2.gameObject.transform);
                                   chain3.transform.localPosition = chain2.transform.localPosition;
                                   chain3.transform.localScale = new Vector3(1f, 1f);

                                   HingeJoint2D chain3hingeJoint = chain3.GetOrAddComponent<HingeJoint2D>();
                                   chain3hingeJoint.connectedBody = chain2.gameObject.GetComponent<Rigidbody2D>();
                                   chain3hingeJoint.anchor = new Vector3(0f, 0f);

                                   JointAngleLimits2D chain3limits = hingeJoint.limits;
                                   chain3limits.min = 700;
                                   chain3limits.max = -700;
                                   chain3hingeJoint.limits = chain3limits;
                                   chain3hingeJoint.useLimits = false;

                                   chain3.transform.localPosition = new Vector3(0f, 0.1f);//0f, 0.2f

                            chain3.gameObject.layer = 9;


                       var chain4 = new GameObject("chain4");
                       chain4 = GameObject.Instantiate(ModAPI.FindSpawnable("Insulator").Prefab);
                                   chain4.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Human");

                                   SpriteRenderer chain4Renderer = chain4.GetComponent<SpriteRenderer>();
                                   chain4Renderer.sprite = ModAPI.LoadSprite("lintestine.png", 1f);
                                   chain4Renderer.sortingLayerName = "Bottom";
                                   foreach (var c in chain4.GetComponents<Collider2D>())
                                   {
                                       GameObject.Destroy(c);
                                   }
chain4.GetComponent<Rigidbody2D>();
                                   chain4.AddComponent<BoxCollider2D>();
			    chain4.transform.SetParent(chain3.gameObject.transform);
                                   chain4.transform.localPosition = chain3.transform.localPosition;
                                   chain4.transform.localScale = new Vector3(1f, 1f);

                                   HingeJoint2D chain4hingeJoint = chain4.GetOrAddComponent<HingeJoint2D>();
                                   chain4hingeJoint.connectedBody = chain3.gameObject.GetComponent<Rigidbody2D>();
                                   chain4hingeJoint.anchor = new Vector3(0f, 0f);

                                   JointAngleLimits2D chain4limits = hingeJoint.limits;
                                   chain4limits.min = 700;
                                   chain4limits.max = -700;
                                   chain4hingeJoint.limits = chain4limits;
                                   chain4hingeJoint.useLimits = false;

                                   chain4.transform.localPosition = new Vector3(0f, 0.1f);//0f, 0.2f

                            chain4.gameObject.layer = 9;


                       var chain5 = new GameObject("chain5");
                       chain5 = GameObject.Instantiate(ModAPI.FindSpawnable("Insulator").Prefab);
                                   chain5.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Human");

                                   SpriteRenderer chain5Renderer = chain5.GetComponent<SpriteRenderer>();
                                   chain5Renderer.sprite = ModAPI.LoadSprite("lintestine.png", 1f);
                                   chain5Renderer.sortingLayerName = "Bottom";
                                   foreach (var c in chain5.GetComponents<Collider2D>())
                                   {
                                       GameObject.Destroy(c);
                                   }
chain5.GetComponent<Rigidbody2D>();
                                   chain5.AddComponent<BoxCollider2D>();
			    chain5.transform.SetParent(chain4.gameObject.transform);
                                   chain5.transform.localPosition = chain4.transform.localPosition;
                                   chain5.transform.localScale = new Vector3(1f, 1f);

                                   HingeJoint2D chain5hingeJoint = chain5.GetOrAddComponent<HingeJoint2D>();
                                   chain5hingeJoint.connectedBody = chain4.gameObject.GetComponent<Rigidbody2D>();
                                   chain5hingeJoint.anchor = new Vector3(0f, 0f);

                                   JointAngleLimits2D chain5limits = hingeJoint.limits;
                                   chain5limits.min = 700;
                                   chain5limits.max = -700;
                                   chain5hingeJoint.limits = chain5limits;
                                   chain5hingeJoint.useLimits = false;

                                   chain5.transform.localPosition = new Vector3(0f, 0.1f);//0f, 0.2f

                            chain5.gameObject.layer = 9;


                       var chain6 = new GameObject("chain6");
                       chain6 = GameObject.Instantiate(ModAPI.FindSpawnable("Insulator").Prefab);
                                   chain6.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Human");

                                   SpriteRenderer chain6Renderer = chain6.GetComponent<SpriteRenderer>();
                                   chain6Renderer.sprite = ModAPI.LoadSprite("lintestine.png", 1f);
                                   chain6Renderer.sortingLayerName = "Bottom";
                                   foreach (var c in chain6.GetComponents<Collider2D>())
                                   {
                                       GameObject.Destroy(c);
                                   }
chain6.GetComponent<Rigidbody2D>();
                                   chain6.AddComponent<BoxCollider2D>();
			    chain6.transform.SetParent(chain5.gameObject.transform);
                                   chain6.transform.localPosition = chain5.transform.localPosition;
                                   chain6.transform.localScale = new Vector3(1f, 1f);

                                   HingeJoint2D chain6hingeJoint = chain6.GetOrAddComponent<HingeJoint2D>();
                                   chain6hingeJoint.connectedBody = chain5.gameObject.GetComponent<Rigidbody2D>();
                                   chain6hingeJoint.anchor = new Vector3(0f, 0f);

                                   JointAngleLimits2D chain6limits = hingeJoint.limits;
                                   chain6limits.min = 700;
                                   chain6limits.max = -700;
                                   chain6hingeJoint.limits = chain5limits;
                                   chain6hingeJoint.useLimits = false;

                                   chain6.transform.localPosition = new Vector3(0f, 0.1f);//0f, 0.2f

                            chain6.gameObject.layer = 9;


                       var chain7 = new GameObject("chain7");
                       chain7 = GameObject.Instantiate(ModAPI.FindSpawnable("Insulator").Prefab);
                                   chain7.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Human");

                                   SpriteRenderer chain7Renderer = chain7.GetComponent<SpriteRenderer>();
                                   chain7Renderer.sprite = ModAPI.LoadSprite("lintestine.png", 1f);
                                   chain7Renderer.sortingLayerName = "Bottom";
                                   foreach (var c in chain7.GetComponents<Collider2D>())
                                   {
                                       GameObject.Destroy(c);
                                   }
chain7.GetComponent<Rigidbody2D>();
                                   chain7.AddComponent<BoxCollider2D>();
			    chain7.transform.SetParent(chain6.gameObject.transform);
                                   chain7.transform.localPosition = chain6.transform.localPosition;
                                   chain7.transform.localScale = new Vector3(1f, 1f);

                                   HingeJoint2D chain7hingeJoint = chain7.GetOrAddComponent<HingeJoint2D>();
                                   chain7hingeJoint.connectedBody = chain6.gameObject.GetComponent<Rigidbody2D>();
                                   chain7hingeJoint.anchor = new Vector3(0f, 0f);

                                   JointAngleLimits2D chain7limits = hingeJoint.limits;
                                   chain7limits.min = 700;
                                   chain7limits.max = -700;
                                   chain7hingeJoint.limits = chain5limits;
                                   chain7hingeJoint.useLimits = false;

                                   chain7.transform.localPosition = new Vector3(0f, 0.1f);//0f, 0.2f

                            chain7.gameObject.layer = 9;


                       var chain8 = new GameObject("chain8");
                       chain8 = GameObject.Instantiate(ModAPI.FindSpawnable("Insulator").Prefab);
                                   chain8.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Human");

                                   SpriteRenderer chain8Renderer = chain8.GetComponent<SpriteRenderer>();
                                   chain8Renderer.sprite = ModAPI.LoadSprite("lintestine.png", 1f);
                                   chain8Renderer.sortingLayerName = "Bottom";
                                   foreach (var c in chain8.GetComponents<Collider2D>())
                                   {
                                       GameObject.Destroy(c);
                                   }
chain8.GetComponent<Rigidbody2D>();
                                   chain8.AddComponent<BoxCollider2D>();
			    chain8.transform.SetParent(chain7.gameObject.transform);
                                   chain8.transform.localPosition = chain7.transform.localPosition;
                                   chain8.transform.localScale = new Vector3(1f, 1f);

                                   HingeJoint2D chain8hingeJoint = chain8.GetOrAddComponent<HingeJoint2D>();
                                   chain8hingeJoint.connectedBody = chain7.gameObject.GetComponent<Rigidbody2D>();
                                   chain8hingeJoint.anchor = new Vector3(0f, 0f);

                                   JointAngleLimits2D chain8limits = hingeJoint.limits;
                                   chain8limits.min = 700;
                                   chain8limits.max = -700;
                                   chain8hingeJoint.limits = chain5limits;
                                   chain8hingeJoint.useLimits = false;

                                   chain8.transform.localPosition = new Vector3(0f, 0.1f);//0f, 0.2f

                            chain8.gameObject.layer = 9;


                       var chain9 = new GameObject("chain9");
                       chain9 = GameObject.Instantiate(ModAPI.FindSpawnable("Insulator").Prefab);
                                   chain9.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Human");

                                   SpriteRenderer chain9Renderer = chain9.GetComponent<SpriteRenderer>();
                                   chain9Renderer.sprite = ModAPI.LoadSprite("lintestine.png", 1f);
                                   chain9Renderer.sortingLayerName = "Bottom";
                                   foreach (var c in chain9.GetComponents<Collider2D>())
                                   {
                                       GameObject.Destroy(c);
                                   }
chain9.GetComponent<Rigidbody2D>();
                                   chain9.AddComponent<BoxCollider2D>();
			    chain9.transform.SetParent(chain8.gameObject.transform);
                                   chain9.transform.localPosition = chain8.transform.localPosition;
                                   chain9.transform.localScale = new Vector3(1f, 1f);

                                   HingeJoint2D chain9hingeJoint = chain9.GetOrAddComponent<HingeJoint2D>();
                                   chain9hingeJoint.connectedBody = chain8.gameObject.GetComponent<Rigidbody2D>();
                                   chain9hingeJoint.anchor = new Vector3(0f, 0f);

                                   JointAngleLimits2D chain9limits = hingeJoint.limits;
                                   chain9limits.min = 700;
                                   chain9limits.max = -700;
                                   chain9hingeJoint.limits = chain5limits;
                                   chain9hingeJoint.useLimits = false;

                                   chain9.transform.localPosition = new Vector3(0f, 0.1f);//0f, 0.2f

                            chain9.gameObject.layer = 9;
 

                       var chain11 = new GameObject("chain11");
                       chain11 = GameObject.Instantiate(ModAPI.FindSpawnable("Insulator").Prefab);
                                   chain11.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Human");

                                   SpriteRenderer chain11Renderer = chain11.GetComponent<SpriteRenderer>();
                                   chain11Renderer.sprite = ModAPI.LoadSprite("lintestine.png", 1f);
                                   chain11Renderer.sortingLayerName = "Bottom";
                                   foreach (var c in chain11.GetComponents<Collider2D>())
                                   {
                                       GameObject.Destroy(c);
                                   }
chain11.GetComponent<Rigidbody2D>();
                                   chain11.AddComponent<BoxCollider2D>();
			    chain11.transform.SetParent(chain9.gameObject.transform);
                                   chain11.transform.localPosition = chain9.transform.localPosition;
                                   chain11.transform.localScale = new Vector3(1f, 1f);

                                   HingeJoint2D chain11hingeJoint = chain11.GetOrAddComponent<HingeJoint2D>();
                                   chain11hingeJoint.connectedBody = chain9.gameObject.GetComponent<Rigidbody2D>();
                                   chain11hingeJoint.anchor = new Vector3(0f, 0f);

                                   JointAngleLimits2D chain11limits = hingeJoint.limits;
                                   chain11limits.min = 700;
                                   chain11limits.max = -700;
                                   chain11hingeJoint.limits = chain5limits;
                                   chain11hingeJoint.useLimits = false;

                                   chain11.transform.localPosition = new Vector3(0f, 0.1f);//0f, 0.2f

                            chain11.gameObject.layer = 9;


                       var chain12 = new GameObject("chain12");
                       chain12 = GameObject.Instantiate(ModAPI.FindSpawnable("Insulator").Prefab);
                                   chain12.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Human");

                                   SpriteRenderer chain12Renderer = chain12.GetComponent<SpriteRenderer>();
                                   chain12Renderer.sprite = ModAPI.LoadSprite("lintestine.png", 1f);
                                   chain12Renderer.sortingLayerName = "Bottom";
                                   foreach (var c in chain12.GetComponents<Collider2D>())
                                   {
                                       GameObject.Destroy(c);
                                   }
chain12.GetComponent<Rigidbody2D>();
                                   chain12.AddComponent<BoxCollider2D>();
			    chain12.transform.SetParent(chain11.gameObject.transform);
                                   chain12.transform.localPosition = chain11.transform.localPosition;
                                   chain12.transform.localScale = new Vector3(1f, 1f);

                                   HingeJoint2D chain12hingeJoint = chain12.GetOrAddComponent<HingeJoint2D>();
                                   chain12hingeJoint.connectedBody = chain11.gameObject.GetComponent<Rigidbody2D>();
                                   chain12hingeJoint.anchor = new Vector3(0f, 0f);

                                   JointAngleLimits2D chain12limits = hingeJoint.limits;
                                   chain12limits.min = 700;
                                   chain12limits.max = -700;
                                   chain12hingeJoint.limits = chain5limits;
                                   chain12hingeJoint.useLimits = false;

                                   chain12.transform.localPosition = new Vector3(0f, 0.1f);//0f, 0.2f

                            chain12.gameObject.layer = 9;


                       var chain13 = new GameObject("chain13");
                       chain13 = GameObject.Instantiate(ModAPI.FindSpawnable("Insulator").Prefab);
                                   chain13.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Human");

                                   SpriteRenderer chain13Renderer = chain13.GetComponent<SpriteRenderer>();
                                   chain13Renderer.sprite = ModAPI.LoadSprite("lintestine.png", 1f);
                                   chain13Renderer.sortingLayerName = "Bottom";
                                   foreach (var c in chain13.GetComponents<Collider2D>())
                                   {
                                       GameObject.Destroy(c);
                                   }
chain13.GetComponent<Rigidbody2D>();
                                   chain13.AddComponent<BoxCollider2D>();
			    chain13.transform.SetParent(chain12.gameObject.transform);
                                   chain13.transform.localPosition = chain12.transform.localPosition;
                                   chain13.transform.localScale = new Vector3(1f, 1f);

                                   HingeJoint2D chain13hingeJoint = chain13.GetOrAddComponent<HingeJoint2D>();
                                   chain13hingeJoint.connectedBody = chain12.gameObject.GetComponent<Rigidbody2D>();
                                   chain13hingeJoint.anchor = new Vector3(0f, 0f);

                                   JointAngleLimits2D chain13limits = hingeJoint.limits;
                                   chain13limits.min = 700;
                                   chain13limits.max = -700;
                                   chain13hingeJoint.limits = chain5limits;
                                   chain13hingeJoint.useLimits = false;

                                   chain13.transform.localPosition = new Vector3(0f, 0.1f);//0f, 0.2f

                            chain13.gameObject.layer = 9;


                       var chain14 = new GameObject("chain14");
                       chain14 = GameObject.Instantiate(ModAPI.FindSpawnable("Insulator").Prefab);
                                   chain14.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Human");

                                   SpriteRenderer chain14Renderer = chain14.GetComponent<SpriteRenderer>();
                                   chain14Renderer.sprite = ModAPI.LoadSprite("lintestine.png", 1f);
                                   chain14Renderer.sortingLayerName = "Bottom";
                                   foreach (var c in chain14.GetComponents<Collider2D>())
                                   {
                                       GameObject.Destroy(c);
                                   }
chain14.GetComponent<Rigidbody2D>();
                                   chain14.AddComponent<BoxCollider2D>();
			    chain14.transform.SetParent(chain13.gameObject.transform);
                                   chain14.transform.localPosition = chain13.transform.localPosition;
                                   chain14.transform.localScale = new Vector3(1f, 1f);

                                   HingeJoint2D chain14hingeJoint = chain14.GetOrAddComponent<HingeJoint2D>();
                                   chain14hingeJoint.connectedBody = chain13.gameObject.GetComponent<Rigidbody2D>();
                                   chain14hingeJoint.anchor = new Vector3(0f, 0f);

                                   JointAngleLimits2D chain14limits = hingeJoint.limits;
                                   chain14limits.min = 700;
                                   chain14limits.max = -700;
                                   chain14hingeJoint.limits = chain5limits;
                                   chain14hingeJoint.useLimits = false;

                                   chain14.transform.localPosition = new Vector3(0f, 0.1f);//0f, 0.2f

                            chain14.gameObject.layer = 9;


                       var chain15 = new GameObject("chain15");
                       chain15 = GameObject.Instantiate(ModAPI.FindSpawnable("Insulator").Prefab);
                                   chain15.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Human");

                                   SpriteRenderer chain15Renderer = chain15.GetComponent<SpriteRenderer>();
                                   chain15Renderer.sprite = ModAPI.LoadSprite("lintestine.png", 1f);
                                   chain15Renderer.sortingLayerName = "Bottom";
                                   foreach (var c in chain15.GetComponents<Collider2D>())
                                   {
                                       GameObject.Destroy(c);
                                   }
chain15.GetComponent<Rigidbody2D>();
                                   chain15.AddComponent<BoxCollider2D>();
			    chain15.transform.SetParent(chain14.gameObject.transform);
                                   chain15.transform.localPosition = chain14.transform.localPosition;
                                   chain15.transform.localScale = new Vector3(1f, 1f);

                                   HingeJoint2D chain15hingeJoint = chain15.GetOrAddComponent<HingeJoint2D>();
                                   chain15hingeJoint.connectedBody = chain14.gameObject.GetComponent<Rigidbody2D>();
                                   chain15hingeJoint.anchor = new Vector3(0f, 0f);

                                   JointAngleLimits2D chain15limits = hingeJoint.limits;
                                   chain15limits.min = 700;
                                   chain15limits.max = -700;
                                   chain15hingeJoint.limits = chain5limits;
                                   chain15hingeJoint.useLimits = false;

                                   chain15.transform.localPosition = new Vector3(0f, 0.1f);//0f, 0.2f

                            chain15.gameObject.layer = 9;

                       var chain16 = new GameObject("chain16");
                       chain16 = GameObject.Instantiate(ModAPI.FindSpawnable("Insulator").Prefab);
                                   chain16.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Human");

                                   SpriteRenderer chain16Renderer = chain16.GetComponent<SpriteRenderer>();
                                   chain16Renderer.sprite = ModAPI.LoadSprite("lintestine.png", 1f);
                                   chain16Renderer.sortingLayerName = "Bottom";
                                   foreach (var c in chain16.GetComponents<Collider2D>())
                                   {
                                       GameObject.Destroy(c);
                                   }
chain16.GetComponent<Rigidbody2D>();
                                   chain16.AddComponent<BoxCollider2D>();
			    chain16.transform.SetParent(chain15.gameObject.transform);
                                   chain16.transform.localPosition = chain15.transform.localPosition;
                                   chain16.transform.localScale = new Vector3(1f, 1f);

                                   HingeJoint2D chain16hingeJoint = chain16.GetOrAddComponent<HingeJoint2D>();
                                   chain16hingeJoint.connectedBody = chain15.gameObject.GetComponent<Rigidbody2D>();
                                   chain16hingeJoint.anchor = new Vector3(0f, 0f);

                                   JointAngleLimits2D chain16limits = hingeJoint.limits;
                                   chain16limits.min = 700;
                                   chain16limits.max = -700;
                                   chain16hingeJoint.limits = chain5limits;
                                   chain16hingeJoint.useLimits = false;

                                   chain16.transform.localPosition = new Vector3(0f, 0.1f);//0f, 0.2f

        var phys = chain16.GetComponent<PhysicalBehaviour>();
        var prop = ModAPI.FindPhysicalProperties("Human");
        phys.Properties = prop;

        var cols = Instance.GetComponentsInChildren<Collider2D>();
                        foreach (var col1 in cols)
                        {
                            foreach (var col2 in cols)
                            {
                                Physics2D.IgnoreCollision(col1, col2);
                            }
                        }

                           }
                        }
                      );
                      ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Insulator"),
        NameOverride = "sintestineobject",
        DescriptionOverride = " ", 
        CategoryOverride = ModAPI.FindCategory(" "), 
        ThumbnailOverride = ModAPI.LoadSprite("sintestine.png"), 
        AfterSpawn = (Instance) => 
        {
            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sintestine.png");
            Instance.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Human");
            
            Instance.layer = 9;
            Instance.FixColliders();

                              var chain = new GameObject("chain");
                              chain = GameObject.Instantiate(ModAPI.FindSpawnable("Insulator").Prefab);
                                          chain.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Human");

                              SpriteRenderer chainRenderer = chain.GetComponent<SpriteRenderer>();
                                          chainRenderer.sprite = ModAPI.LoadSprite("sintestine.png", 1f);
                                          chainRenderer.sortingLayerName = "Middle";
                                          foreach (var c in chain.GetComponents<Collider2D>())
                                          {
                                              GameObject.Destroy(c);
                                          }
                                          chain.AddComponent<CircleCollider2D>();
			    chain.transform.SetParent(Instance.transform);
                                          chain.transform.localScale = new Vector3(1f, 1f);


                                   HingeJoint2D hingeJoint = chain.GetOrAddComponent<HingeJoint2D>();
                                   hingeJoint.connectedBody = Instance.GetComponent<Rigidbody2D>();
                                   hingeJoint.anchor = new Vector3(0f, 0f);

                                   JointAngleLimits2D limits = hingeJoint.limits;
                                   limits.min = 700;
                                   limits.max = -700;
                                   hingeJoint.limits = limits;
                                   hingeJoint.useLimits = false;

                            chain.gameObject.layer = 9;


                                   chain.transform.localPosition = new Vector3(0f, 0.1f);//0f, 0.2f


                       var chain2 = new GameObject("chain2");
                       chain2 = GameObject.Instantiate(ModAPI.FindSpawnable("Insulator").Prefab);
                                   chain2.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Human");

                                   SpriteRenderer chain2Renderer = chain2.GetComponent<SpriteRenderer>();
                                   chain2Renderer.sprite = ModAPI.LoadSprite("sintestine.png", 1f);
                                   chain2Renderer.sortingLayerName = "Bottom";
                                   foreach (var c in chain2.GetComponents<Collider2D>())
                                   {
                                       GameObject.Destroy(c);
                                   }
chain2.GetComponent<Rigidbody2D>();
                                   chain2.AddComponent<BoxCollider2D>();
			    chain2.transform.SetParent(chain.gameObject.transform);
                                   chain2.transform.localPosition = chain.transform.localPosition;
                                   chain2.transform.localScale = new Vector3(1f, 1f);

                                   HingeJoint2D chain2hingeJoint = chain2.GetOrAddComponent<HingeJoint2D>();
                                   chain2hingeJoint.connectedBody = chain.gameObject.GetComponent<Rigidbody2D>();
                                   chain2hingeJoint.anchor = new Vector3(0f, 0f);

                                   JointAngleLimits2D chain2limits = hingeJoint.limits;
                                   chain2limits.min = 700;
                                   chain2limits.max = -700;
                                   chain2hingeJoint.limits = chain2limits;
                                   chain2hingeJoint.useLimits = false;

                                   chain2.transform.localPosition = new Vector3(0f, 0.1f);//0f, 0.2f

                            chain2.gameObject.layer = 9;


                       var chain3 = new GameObject("chain3");
                       chain3 = GameObject.Instantiate(ModAPI.FindSpawnable("Insulator").Prefab);
                                   chain3.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Human");

                                   SpriteRenderer chain3Renderer = chain3.GetComponent<SpriteRenderer>();
                                   chain3Renderer.sprite = ModAPI.LoadSprite("sintestine.png", 1f);
                                   chain3Renderer.sortingLayerName = "Bottom";
                                   foreach (var c in chain3.GetComponents<Collider2D>())
                                   {
                                       GameObject.Destroy(c);
                                   }
chain3.GetComponent<Rigidbody2D>();
                                   chain3.AddComponent<BoxCollider2D>();
			    chain3.transform.SetParent(chain2.gameObject.transform);
                                   chain3.transform.localPosition = chain2.transform.localPosition;
                                   chain3.transform.localScale = new Vector3(1f, 1f);

                                   HingeJoint2D chain3hingeJoint = chain3.GetOrAddComponent<HingeJoint2D>();
                                   chain3hingeJoint.connectedBody = chain2.gameObject.GetComponent<Rigidbody2D>();
                                   chain3hingeJoint.anchor = new Vector3(0f, 0f);

                                   JointAngleLimits2D chain3limits = hingeJoint.limits;
                                   chain3limits.min = 700;
                                   chain3limits.max = -700;
                                   chain3hingeJoint.limits = chain3limits;
                                   chain3hingeJoint.useLimits = false;

                                   chain3.transform.localPosition = new Vector3(0f, 0.1f);//0f, 0.2f

                            chain3.gameObject.layer = 9;


                       var chain4 = new GameObject("chain4");
                       chain4 = GameObject.Instantiate(ModAPI.FindSpawnable("Insulator").Prefab);
                                   chain4.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Human");

                                   SpriteRenderer chain4Renderer = chain4.GetComponent<SpriteRenderer>();
                                   chain4Renderer.sprite = ModAPI.LoadSprite("sintestine.png", 1f);
                                   chain4Renderer.sortingLayerName = "Bottom";
                                   foreach (var c in chain4.GetComponents<Collider2D>())
                                   {
                                       GameObject.Destroy(c);
                                   }
chain4.GetComponent<Rigidbody2D>();
                                   chain4.AddComponent<BoxCollider2D>();
			    chain4.transform.SetParent(chain3.gameObject.transform);
                                   chain4.transform.localPosition = chain3.transform.localPosition;
                                   chain4.transform.localScale = new Vector3(1f, 1f);

                                   HingeJoint2D chain4hingeJoint = chain4.GetOrAddComponent<HingeJoint2D>();
                                   chain4hingeJoint.connectedBody = chain3.gameObject.GetComponent<Rigidbody2D>();
                                   chain4hingeJoint.anchor = new Vector3(0f, 0f);

                                   JointAngleLimits2D chain4limits = hingeJoint.limits;
                                   chain4limits.min = 700;
                                   chain4limits.max = -700;
                                   chain4hingeJoint.limits = chain4limits;
                                   chain4hingeJoint.useLimits = false;

                                   chain4.transform.localPosition = new Vector3(0f, 0.1f);//0f, 0.2f

                            chain4.gameObject.layer = 9;


                       var chain5 = new GameObject("chain5");
                       chain5 = GameObject.Instantiate(ModAPI.FindSpawnable("Insulator").Prefab);
                                   chain5.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Human");

                                   SpriteRenderer chain5Renderer = chain5.GetComponent<SpriteRenderer>();
                                   chain5Renderer.sprite = ModAPI.LoadSprite("sintestine.png", 1f);
                                   chain5Renderer.sortingLayerName = "Bottom";
                                   foreach (var c in chain5.GetComponents<Collider2D>())
                                   {
                                       GameObject.Destroy(c);
                                   }
chain5.GetComponent<Rigidbody2D>();
                                   chain5.AddComponent<BoxCollider2D>();
			    chain5.transform.SetParent(chain4.gameObject.transform);
                                   chain5.transform.localPosition = chain4.transform.localPosition;
                                   chain5.transform.localScale = new Vector3(1f, 1f);

                                   HingeJoint2D chain5hingeJoint = chain5.GetOrAddComponent<HingeJoint2D>();
                                   chain5hingeJoint.connectedBody = chain4.gameObject.GetComponent<Rigidbody2D>();
                                   chain5hingeJoint.anchor = new Vector3(0f, 0f);

                                   JointAngleLimits2D chain5limits = hingeJoint.limits;
                                   chain5limits.min = 700;
                                   chain5limits.max = -700;
                                   chain5hingeJoint.limits = chain5limits;
                                   chain5hingeJoint.useLimits = false;

                                   chain5.transform.localPosition = new Vector3(0f, 0.1f);//0f, 0.2f

                            chain5.gameObject.layer = 9;


                       var chain6 = new GameObject("chain6");
                       chain6 = GameObject.Instantiate(ModAPI.FindSpawnable("Insulator").Prefab);
                                   chain6.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Human");

                                   SpriteRenderer chain6Renderer = chain6.GetComponent<SpriteRenderer>();
                                   chain6Renderer.sprite = ModAPI.LoadSprite("sintestine.png", 1f);
                                   chain6Renderer.sortingLayerName = "Bottom";
                                   foreach (var c in chain6.GetComponents<Collider2D>())
                                   {
                                       GameObject.Destroy(c);
                                   }
chain6.GetComponent<Rigidbody2D>();
                                   chain6.AddComponent<BoxCollider2D>();
			    chain6.transform.SetParent(chain5.gameObject.transform);
                                   chain6.transform.localPosition = chain5.transform.localPosition;
                                   chain6.transform.localScale = new Vector3(1f, 1f);

                                   HingeJoint2D chain6hingeJoint = chain6.GetOrAddComponent<HingeJoint2D>();
                                   chain6hingeJoint.connectedBody = chain5.gameObject.GetComponent<Rigidbody2D>();
                                   chain6hingeJoint.anchor = new Vector3(0f, 0f);

                                   JointAngleLimits2D chain6limits = hingeJoint.limits;
                                   chain6limits.min = 700;
                                   chain6limits.max = -700;
                                   chain6hingeJoint.limits = chain5limits;
                                   chain6hingeJoint.useLimits = false;

                                   chain6.transform.localPosition = new Vector3(0f, 0.1f);//0f, 0.2f

                            chain6.gameObject.layer = 9;


                       var chain7 = new GameObject("chain7");
                       chain7 = GameObject.Instantiate(ModAPI.FindSpawnable("Insulator").Prefab);
                                   chain7.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Human");

                                   SpriteRenderer chain7Renderer = chain7.GetComponent<SpriteRenderer>();
                                   chain7Renderer.sprite = ModAPI.LoadSprite("sintestine.png", 1f);
                                   chain7Renderer.sortingLayerName = "Bottom";
                                   foreach (var c in chain7.GetComponents<Collider2D>())
                                   {
                                       GameObject.Destroy(c);
                                   }
chain7.GetComponent<Rigidbody2D>();
                                   chain7.AddComponent<BoxCollider2D>();
			    chain7.transform.SetParent(chain6.gameObject.transform);
                                   chain7.transform.localPosition = chain6.transform.localPosition;
                                   chain7.transform.localScale = new Vector3(1f, 1f);

                                   HingeJoint2D chain7hingeJoint = chain7.GetOrAddComponent<HingeJoint2D>();
                                   chain7hingeJoint.connectedBody = chain6.gameObject.GetComponent<Rigidbody2D>();
                                   chain7hingeJoint.anchor = new Vector3(0f, 0f);

                                   JointAngleLimits2D chain7limits = hingeJoint.limits;
                                   chain7limits.min = 700;
                                   chain7limits.max = -700;
                                   chain7hingeJoint.limits = chain5limits;
                                   chain7hingeJoint.useLimits = false;

                                   chain7.transform.localPosition = new Vector3(0f, 0.1f);//0f, 0.2f

                            chain7.gameObject.layer = 9;


                       var chain8 = new GameObject("chain8");
                       chain8 = GameObject.Instantiate(ModAPI.FindSpawnable("Insulator").Prefab);
                                   chain8.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Human");

                                   SpriteRenderer chain8Renderer = chain8.GetComponent<SpriteRenderer>();
                                   chain8Renderer.sprite = ModAPI.LoadSprite("sintestine.png", 1f);
                                   chain8Renderer.sortingLayerName = "Bottom";
                                   foreach (var c in chain8.GetComponents<Collider2D>())
                                   {
                                       GameObject.Destroy(c);
                                   }
chain8.GetComponent<Rigidbody2D>();
                                   chain8.AddComponent<BoxCollider2D>();
			    chain8.transform.SetParent(chain7.gameObject.transform);
                                   chain8.transform.localPosition = chain7.transform.localPosition;
                                   chain8.transform.localScale = new Vector3(1f, 1f);

                                   HingeJoint2D chain8hingeJoint = chain8.GetOrAddComponent<HingeJoint2D>();
                                   chain8hingeJoint.connectedBody = chain7.gameObject.GetComponent<Rigidbody2D>();
                                   chain8hingeJoint.anchor = new Vector3(0f, 0f);

                                   JointAngleLimits2D chain8limits = hingeJoint.limits;
                                   chain8limits.min = 700;
                                   chain8limits.max = -700;
                                   chain8hingeJoint.limits = chain5limits;
                                   chain8hingeJoint.useLimits = false;

                                   chain8.transform.localPosition = new Vector3(0f, 0.1f);//0f, 0.2f

                            chain8.gameObject.layer = 9;


                       var chain9 = new GameObject("chain9");
                       chain9 = GameObject.Instantiate(ModAPI.FindSpawnable("Insulator").Prefab);
                                   chain9.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Human");

                                   SpriteRenderer chain9Renderer = chain9.GetComponent<SpriteRenderer>();
                                   chain9Renderer.sprite = ModAPI.LoadSprite("sintestine.png", 1f);
                                   chain9Renderer.sortingLayerName = "Bottom";
                                   foreach (var c in chain9.GetComponents<Collider2D>())
                                   {
                                       GameObject.Destroy(c);
                                   }
chain9.GetComponent<Rigidbody2D>();
                                   chain9.AddComponent<BoxCollider2D>();
			    chain9.transform.SetParent(chain8.gameObject.transform);
                                   chain9.transform.localPosition = chain8.transform.localPosition;
                                   chain9.transform.localScale = new Vector3(1f, 1f);

                                   HingeJoint2D chain9hingeJoint = chain9.GetOrAddComponent<HingeJoint2D>();
                                   chain9hingeJoint.connectedBody = chain8.gameObject.GetComponent<Rigidbody2D>();
                                   chain9hingeJoint.anchor = new Vector3(0f, 0f);

                                   JointAngleLimits2D chain9limits = hingeJoint.limits;
                                   chain9limits.min = 700;
                                   chain9limits.max = -700;
                                   chain9hingeJoint.limits = chain5limits;
                                   chain9hingeJoint.useLimits = false;

                                   chain9.transform.localPosition = new Vector3(0f, 0.1f);//0f, 0.2f

                            chain9.gameObject.layer = 9;
 

                       var chain11 = new GameObject("chain11");
                       chain11 = GameObject.Instantiate(ModAPI.FindSpawnable("Insulator").Prefab);
                                   chain11.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Human");

                                   SpriteRenderer chain11Renderer = chain11.GetComponent<SpriteRenderer>();
                                   chain11Renderer.sprite = ModAPI.LoadSprite("sintestine.png", 1f);
                                   chain11Renderer.sortingLayerName = "Bottom";
                                   foreach (var c in chain11.GetComponents<Collider2D>())
                                   {
                                       GameObject.Destroy(c);
                                   }
chain11.GetComponent<Rigidbody2D>();
                                   chain11.AddComponent<BoxCollider2D>();
			    chain11.transform.SetParent(chain9.gameObject.transform);
                                   chain11.transform.localPosition = chain9.transform.localPosition;
                                   chain11.transform.localScale = new Vector3(1f, 1f);

                                   HingeJoint2D chain11hingeJoint = chain11.GetOrAddComponent<HingeJoint2D>();
                                   chain11hingeJoint.connectedBody = chain9.gameObject.GetComponent<Rigidbody2D>();
                                   chain11hingeJoint.anchor = new Vector3(0f, 0f);

                                   JointAngleLimits2D chain11limits = hingeJoint.limits;
                                   chain11limits.min = 700;
                                   chain11limits.max = -700;
                                   chain11hingeJoint.limits = chain5limits;
                                   chain11hingeJoint.useLimits = false;

                                   chain11.transform.localPosition = new Vector3(0f, 0.1f);//0f, 0.2f

                            chain11.gameObject.layer = 9;

                       var chain16 = new GameObject("chain16");
                       chain16 = GameObject.Instantiate(ModAPI.FindSpawnable("Insulator").Prefab);
                                   chain16.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Human");

                                   SpriteRenderer chain16Renderer = chain16.GetComponent<SpriteRenderer>();
                                   chain16Renderer.sprite = ModAPI.LoadSprite("sintestine.png", 1f);
                                   chain16Renderer.sortingLayerName = "Bottom";
                                   foreach (var c in chain16.GetComponents<Collider2D>())
                                   {
                                       GameObject.Destroy(c);
                                   }
chain16.GetComponent<Rigidbody2D>();
                                   chain16.AddComponent<BoxCollider2D>();
			    chain16.transform.SetParent(chain11.gameObject.transform);
                                   chain16.transform.localPosition = chain11.transform.localPosition;
                                   chain16.transform.localScale = new Vector3(1f, 1f);

                                   HingeJoint2D chain16hingeJoint = chain16.GetOrAddComponent<HingeJoint2D>();
                                   chain16hingeJoint.connectedBody = chain11.gameObject.GetComponent<Rigidbody2D>();
                                   chain16hingeJoint.anchor = new Vector3(0f, 0f);

                                   JointAngleLimits2D chain16limits = hingeJoint.limits;
                                   chain16limits.min = 700;
                                   chain16limits.max = -700;
                                   chain16hingeJoint.limits = chain5limits;
                                   chain16hingeJoint.useLimits = false;

                                   chain16.transform.localPosition = new Vector3(0f, 0.1f);//0f, 0.2f

        var phys = chain16.GetComponent<PhysicalBehaviour>();
        var prop = ModAPI.FindPhysicalProperties("Human");
        phys.Properties = prop;

        var cols = Instance.GetComponentsInChildren<Collider2D>();
                        foreach (var col1 in cols)
                        {
                            foreach (var col2 in cols)
                            {
                                Physics2D.IgnoreCollision(col1, col2);
                            }
                        }

                           }
                        }
                      );
        }
    }
    public class BrainSplatter : MonoBehaviour
    {
        public bool Ejected = false;
        public bool MakeEye = false;
        public Vector2 eyeConnector = new Vector2(0f, 0f);

        void JointCreated(DistanceJoint2D joint)
        {
            UseWireBehaviour useWireBehaviour = joint.gameObject.AddComponent<UseWireBehaviour>();
            useWireBehaviour.WireColor = new Color(1f, 0.1f, 0.1f, 1f);
            useWireBehaviour.WireMaterial = Resources.Load<Material>("Materials/Wire");
            useWireBehaviour.WireWidth = 0.01f;
            useWireBehaviour.typedJoint = joint;
        }

        public void Splat()
        {
            GameObject BrainMatter = GameObject.Instantiate(ModAPI.FindSpawnable("Pumpkin").Prefab.GetComponent<DestroyableBehaviour>().DebrisPrefab.gameObject.transform.Find("chunks").gameObject);
            BrainMatter.gameObject.transform.position = transform.position;
            BrainMatter.gameObject.GetComponent<ParticleSystem>().startColor = new Color(0.5f, 0.2f, 0.2f, 1f); 
            GameObject BrainMatter2 = GameObject.Instantiate(ModAPI.FindSpawnable("Pumpkin").Prefab.GetComponent<DestroyableBehaviour>().DebrisPrefab.gameObject.transform.Find("chunks").gameObject);
            BrainMatter2.gameObject.transform.position = transform.position;
            BrainMatter2.gameObject.GetComponent<ParticleSystem>().startColor = new Color(1f, 0f, 0.4f, 1f); 
            GameObject BrainMatter3 = GameObject.Instantiate(ModAPI.FindSpawnable("Pumpkin").Prefab.GetComponent<DestroyableBehaviour>().DebrisPrefab.gameObject.transform.Find("chunks").gameObject);
            BrainMatter3.gameObject.transform.position = transform.position;
            BrainMatter3.gameObject.GetComponent<ParticleSystem>().startColor = new Color(1f, 0.7f, 0.7f, 1f);
            GameObject BrainMatter4 = GameObject.Instantiate(ModAPI.FindSpawnable("Pumpkin").Prefab.GetComponent<DestroyableBehaviour>().DebrisPrefab.gameObject.transform.Find("chunks").gameObject);
            BrainMatter4.gameObject.transform.position = transform.position;
            BrainMatter4.gameObject.GetComponent<ParticleSystem>().startColor = new Color(0.6f, 0f, 0.2f, 1f);
            System.Random rand = new System.Random();
            var number32 = rand.Next(3);
                        if (number32 == 1)
                        {
                            GameObject brian = GameObject.Instantiate(ModAPI.FindSpawnable("Rod").Prefab);
                            brian.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Human");
            brian.layer = 9;
            brian.transform.localScale *= 1.2f;
                        brian.transform.position = transform.position;
                            brian.gameObject.GetComponent<SpriteRenderer>().sprite = Mod.brian;
                        var numberaf2 = rand.Next(2);
                        if (numberaf2 == 1)
                        {
                            brian.GetComponent<Rigidbody2D>().angularVelocity = UnityEngine.Random.value * 8f;
                        brian.GetComponent<Rigidbody2D>().velocity = new Vector2(UnityEngine.Random.value * 8f, UnityEngine.Random.value * 8f); 
                        }
                        else
                        {
                            brian.GetComponent<Rigidbody2D>().angularVelocity = -UnityEngine.Random.value * 8f;
                        brian.GetComponent<Rigidbody2D>().velocity = new Vector2(-UnityEngine.Random.value * 8f, -UnityEngine.Random.value * 8f); 
                        }
                        brian.gameObject.GetComponent<SpriteRenderer>().sortingLayerName = "Bottom";
                        ModAPI.CreateParticleEffect("BloodExplosion", brian.transform.position);
                        brian.FixColliders();
                        foreach (var Limbs in transform.root.gameObject.GetComponent<PersonBehaviour>().Limbs)
                        {
                          var DontCollideWithUser = Limbs.gameObject.AddComponent<NoCollide>();
                          DontCollideWithUser.NoCollideSetA = brian.gameObject.transform.root.gameObject.GetComponentsInChildren<Collider2D>();
                          DontCollideWithUser.NoCollideSetB = Limbs.gameObject.GetComponentsInChildren<Collider2D>();
                        }
                        }
        GameObject skullchunk = GameObject.Instantiate(ModAPI.FindSpawnable("Brick").Prefab);
            skullchunk.layer = 9;
            skullchunk.transform.localScale *= 1.3f;
                        skullchunk.transform.position = transform.position;
                        skullchunk.AddComponent<DebrisComponent>();
                            skullchunk.gameObject.GetComponent<SpriteRenderer>().sprite = Mod.skull1;
                        var number2 = rand.Next(2);
                        if (number2 == 1)
                        {
                            skullchunk.GetComponent<Rigidbody2D>().angularVelocity = UnityEngine.Random.value * 8f;
                        skullchunk.GetComponent<Rigidbody2D>().velocity = new Vector2(UnityEngine.Random.value * 8f, UnityEngine.Random.value * 8f); 
                        }
                        else
                        {
                            skullchunk.GetComponent<Rigidbody2D>().angularVelocity = -UnityEngine.Random.value * 8f;
                        skullchunk.GetComponent<Rigidbody2D>().velocity = new Vector2(-UnityEngine.Random.value * 8f, -UnityEngine.Random.value * 8f); 
                        }
                        skullchunk.gameObject.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
                        ModAPI.CreateParticleEffect("BloodExplosion", skullchunk.transform.position);
                        skullchunk.FixColliders();
                        GameObject eye = GameObject.Instantiate(ModAPI.FindSpawnable("Activation Fuse").Prefab);
                        eye.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Human");
                        eye.gameObject.GetComponent<SpriteRenderer>().sprite = Mod.eyeball;
                        eye.transform.SetParent(skullchunk.transform);
                        eye.transform.localScale *= 0.6f;
                        eye.transform.position = skullchunk.transform.position + Vector3.up * 0.75f;
                        eye.AddComponent<DebrisComponent>();
                        eye.FixColliders();
                        DistanceJoint2D joint = eye.AddComponent<DistanceJoint2D>();
            joint.maxDistanceOnly = true;
            joint.enableCollision = false;
            joint.distance = 1f;
            joint.autoConfigureDistance = true;
            joint.breakForce = 1f;
            joint.breakTorque = 1f;
            joint.anchor = new Vector2(0f, 0f);
            joint.connectedBody = skullchunk.GetComponent<Rigidbody2D>();
            joint.connectedAnchor = new Vector2(0f, 0f);
            JointCreated(joint);
                        foreach (var Limbs in transform.root.gameObject.GetComponent<PersonBehaviour>().Limbs)
                        {
                          var DontCollideWithUser = Limbs.gameObject.AddComponent<NoCollide>();
                          DontCollideWithUser.NoCollideSetA = skullchunk.gameObject.transform.root.gameObject.GetComponentsInChildren<Collider2D>();
                          DontCollideWithUser.NoCollideSetB = Limbs.gameObject.GetComponentsInChildren<Collider2D>();
                        }
                        GameObject skullcunk = GameObject.Instantiate(ModAPI.FindSpawnable("Brick").Prefab);
            skullcunk.layer = 9;
            skullcunk.transform.localScale *= 1.3f;
                        skullcunk.transform.position = transform.position;
                            skullcunk.gameObject.GetComponent<SpriteRenderer>().sprite = Mod.skull2;
                            skullcunk.AddComponent<DebrisComponent>();
                        var numberf2 = rand.Next(2);
                        if (numberf2 == 1)
                        {
                            skullcunk.GetComponent<Rigidbody2D>().angularVelocity = UnityEngine.Random.value * 8f;
                        skullcunk.GetComponent<Rigidbody2D>().velocity = new Vector2(UnityEngine.Random.value * 8f, UnityEngine.Random.value * 8f); 
                        }
                        else
                        {
                            skullcunk.GetComponent<Rigidbody2D>().angularVelocity = -UnityEngine.Random.value * 8f;
                        skullcunk.GetComponent<Rigidbody2D>().velocity = new Vector2(-UnityEngine.Random.value * 8f, -UnityEngine.Random.value * 8f); 
                        }
                        skullcunk.gameObject.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
                        ModAPI.CreateParticleEffect("BloodExplosion", skullcunk.transform.position);
                        skullcunk.FixColliders();
                        foreach (var Limbs in transform.root.gameObject.GetComponent<PersonBehaviour>().Limbs)
                        {
                          var DontCollideWithUser = Limbs.gameObject.AddComponent<NoCollide>();
                          DontCollideWithUser.NoCollideSetA = skullchunk.gameObject.transform.root.gameObject.GetComponentsInChildren<Collider2D>();
                          DontCollideWithUser.NoCollideSetB = Limbs.gameObject.GetComponentsInChildren<Collider2D>();
                        }
                        GameObject skullcunk2 = GameObject.Instantiate(ModAPI.FindSpawnable("Brick").Prefab);
            skullcunk2.layer = 9;
            skullcunk2.transform.localScale *= 1.3f;
                        skullcunk2.transform.position = transform.position;
                            skullcunk2.gameObject.GetComponent<SpriteRenderer>().sprite = Mod.skull3;
                            skullcunk2.AddComponent<DebrisComponent>();
                        var numbergf2 = rand.Next(2);
                        if (numbergf2 == 1)
                        {
                            skullcunk2.GetComponent<Rigidbody2D>().angularVelocity = UnityEngine.Random.value * 8f;
                        skullcunk2.GetComponent<Rigidbody2D>().velocity = new Vector2(UnityEngine.Random.value * 8f, UnityEngine.Random.value * 8f); 
                        }
                        else
                        {
                            skullcunk2.GetComponent<Rigidbody2D>().angularVelocity = -UnityEngine.Random.value * 8f;
                        skullcunk2.GetComponent<Rigidbody2D>().velocity = new Vector2(-UnityEngine.Random.value * 8f, -UnityEngine.Random.value * 8f); 
                        }
                        skullcunk2.gameObject.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
                        ModAPI.CreateParticleEffect("BloodExplosion", skullcunk2.transform.position);
                        skullcunk2.FixColliders();
                        foreach (var Limbs in transform.root.gameObject.GetComponent<PersonBehaviour>().Limbs)
                        {
                          var DontCollideWithUser = Limbs.gameObject.AddComponent<NoCollide>();
                          DontCollideWithUser.NoCollideSetA = skullcunk2.gameObject.transform.root.gameObject.GetComponentsInChildren<Collider2D>();
                          DontCollideWithUser.NoCollideSetB = Limbs.gameObject.GetComponentsInChildren<Collider2D>();
                        }
                        var DontCollideW2ithUser = skullcunk2.gameObject.AddComponent<NoCollide>();
                          DontCollideW2ithUser.NoCollideSetA = skullcunk.gameObject.transform.root.gameObject.GetComponentsInChildren<Collider2D>();
                          DontCollideW2ithUser.NoCollideSetB = skullcunk2.gameObject.GetComponentsInChildren<Collider2D>();
                          var DontCollideWi2thUser = skullcunk2.gameObject.AddComponent<NoCollide>();
                          DontCollideWi2thUser.NoCollideSetA = skullchunk.gameObject.transform.root.gameObject.GetComponentsInChildren<Collider2D>();
                          DontCollideWi2thUser.NoCollideSetB = skullcunk2.gameObject.GetComponentsInChildren<Collider2D>();
                          var DontColdlideWithUser = skullcunk.gameObject.AddComponent<NoCollide>();
                          DontColdlideWithUser.NoCollideSetA = skullchunk.gameObject.transform.root.gameObject.GetComponentsInChildren<Collider2D>();
                          DontColdlideWithUser.NoCollideSetB = skullcunk.gameObject.GetComponentsInChildren<Collider2D>();
                        GameObject skullchunk2 = GameObject.Instantiate(ModAPI.FindSpawnable("Brick").Prefab);
            skullchunk2.layer = 10;
            skullchunk2.transform.localScale *= 0.5f;
                        skullchunk2.transform.position = transform.position;
                        ModAPI.CreateParticleEffect("BloodExplosion", skullchunk2.transform.position);
                            skullchunk2.gameObject.GetComponent<SpriteRenderer>().sprite = Mod.skull3;
                            skullchunk2.AddComponent<DebrisComponent>();
                        var number23 = rand.Next(2);
                        if (number23 == 1)
                        {
                            skullchunk2.GetComponent<Rigidbody2D>().angularVelocity = UnityEngine.Random.value * 8f;
                        skullchunk2.GetComponent<Rigidbody2D>().velocity = new Vector2(UnityEngine.Random.value * 8f, UnityEngine.Random.value * 8f); 
                        }
                        else
                        {
                            skullchunk2.GetComponent<Rigidbody2D>().angularVelocity = -UnityEngine.Random.value * 8f;
                        skullchunk2.GetComponent<Rigidbody2D>().velocity = new Vector2(-UnityEngine.Random.value * 8f, -UnityEngine.Random.value * 8f); 
                        }
                        skullchunk2.gameObject.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
                        skullchunk2.FixColliders();
                        GameObject skullchunk3 = GameObject.Instantiate(ModAPI.FindSpawnable("Brick").Prefab);
            skullchunk3.layer = 10;
            skullchunk3.AddComponent<DebrisComponent>();
            skullchunk3.transform.localScale *= 0.5f;
            ModAPI.CreateParticleEffect("BloodExplosion", skullchunk3.transform.position);
                        skullchunk3.transform.position = transform.position;
                            skullchunk3.gameObject.GetComponent<SpriteRenderer>().sprite = Mod.skull3;
                        var number223 = rand.Next(2);
                        if (number223 == 1)
                        {
                            skullchunk3.GetComponent<Rigidbody2D>().angularVelocity = UnityEngine.Random.value * 8f;
                        skullchunk3.GetComponent<Rigidbody2D>().velocity = new Vector2(UnityEngine.Random.value * 8f, UnityEngine.Random.value * 8f); 
                        }
                        else
                        {
                            skullchunk3.GetComponent<Rigidbody2D>().angularVelocity = -UnityEngine.Random.value * 8f;
                        skullchunk3.GetComponent<Rigidbody2D>().velocity = new Vector2(-UnityEngine.Random.value * 8f, -UnityEngine.Random.value * 8f); 
                        }
                        skullchunk3.gameObject.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
                        skullchunk3.FixColliders();
                        skullchunk3.gameObject.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
                        skullchunk3.FixColliders();
                        GameObject skullchunk4 = GameObject.Instantiate(ModAPI.FindSpawnable("Brick").Prefab);
            skullchunk4.layer = 10;
            ModAPI.CreateParticleEffect("BloodExplosion", skullchunk4.transform.position);
            skullchunk4.transform.localScale *= 0.4f;
            skullchunk4.AddComponent<DebrisComponent>();
                        skullchunk4.transform.position = transform.position;
                            skullchunk4.gameObject.GetComponent<SpriteRenderer>().sprite = Mod.skull3;
                        var number2223 = rand.Next(2);
                        if (number2223 == 1)
                        {
                            skullchunk4.GetComponent<Rigidbody2D>().angularVelocity = UnityEngine.Random.value * 8f;
                        skullchunk4.GetComponent<Rigidbody2D>().velocity = new Vector2(UnityEngine.Random.value * 8f, UnityEngine.Random.value * 8f); 
                        }
                        else
                        {
                            skullchunk4.GetComponent<Rigidbody2D>().angularVelocity = -UnityEngine.Random.value * 8f;
                        skullchunk4.GetComponent<Rigidbody2D>().velocity = new Vector2(-UnityEngine.Random.value * 8f, -UnityEngine.Random.value * 8f); 
                        }
                        skullchunk4.gameObject.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
                        skullchunk4.FixColliders();
                        GameObject chunk = GameObject.Instantiate(ModAPI.FindSpawnable("Brick").Prefab);
            chunk.layer = 9;
            ModAPI.CreateParticleEffect("BloodExplosion", chunk.transform.position);
            chunk.transform.localScale *= 1f;
                        chunk.transform.position = transform.position;
                        chunk.AddComponent<DebrisComponent>();
                            chunk.gameObject.GetComponent<SpriteRenderer>().sprite = Mod.chunk;
                            chunk.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Human");
                        var number22223 = rand.Next(2);
                        if (number22223 == 1)
                        {
                            chunk.GetComponent<Rigidbody2D>().angularVelocity = UnityEngine.Random.value * 8f;
                        chunk.GetComponent<Rigidbody2D>().velocity = new Vector2(UnityEngine.Random.value * 8f, UnityEngine.Random.value * 8f); 
                        }
                        else
                        {
                            chunk.GetComponent<Rigidbody2D>().angularVelocity = -UnityEngine.Random.value * 8f;
                        chunk.GetComponent<Rigidbody2D>().velocity = new Vector2(-UnityEngine.Random.value * 8f, -UnityEngine.Random.value * 8f); 
                        }
                        chunk.gameObject.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
                        chunk.FixColliders();
                        foreach (var Limbs in transform.root.gameObject.GetComponent<PersonBehaviour>().Limbs)
                        {
                          var DontCollideWithUser = Limbs.gameObject.AddComponent<NoCollide>();
                          DontCollideWithUser.NoCollideSetA = chunk.gameObject.transform.root.gameObject.GetComponentsInChildren<Collider2D>();
                          DontCollideWithUser.NoCollideSetB = Limbs.gameObject.GetComponentsInChildren<Collider2D>();
                        }
                        GameObject chunk2 = GameObject.Instantiate(ModAPI.FindSpawnable("Brick").Prefab);
            chunk2.layer = 9;
            ModAPI.CreateParticleEffect("BloodExplosion", chunk2.transform.position);
            chunk2.transform.localScale *= 0.8f;
            chunk2.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Human");
                        chunk2.transform.position = transform.position;
                        chunk2.AddComponent<DebrisComponent>();
                            chunk2.gameObject.GetComponent<SpriteRenderer>().sprite = Mod.chunk;
                        var number222223 = rand.Next(2);
                        if (number222223 == 1)
                        {
                            chunk2.GetComponent<Rigidbody2D>().angularVelocity = UnityEngine.Random.value * 8f;
                        chunk2.GetComponent<Rigidbody2D>().velocity = new Vector2(UnityEngine.Random.value * 8f, UnityEngine.Random.value * 8f); 
                        }
                        else
                        {
                            chunk2.GetComponent<Rigidbody2D>().angularVelocity = -UnityEngine.Random.value * 8f;
                        chunk2.GetComponent<Rigidbody2D>().velocity = new Vector2(-UnityEngine.Random.value * 8f, -UnityEngine.Random.value * 8f); 
                        }
                        chunk2.gameObject.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
                        chunk2.FixColliders();
                        foreach (var Limbs in transform.root.gameObject.GetComponent<PersonBehaviour>().Limbs)
                        {
                          var DontCollideWithUser = Limbs.gameObject.AddComponent<NoCollide>();
                          DontCollideWithUser.NoCollideSetA = chunk2.gameObject.transform.root.gameObject.GetComponentsInChildren<Collider2D>();
                          DontCollideWithUser.NoCollideSetB = Limbs.gameObject.GetComponentsInChildren<Collider2D>();
                        }
                        GameObject chunk3 = GameObject.Instantiate(ModAPI.FindSpawnable("Brick").Prefab);
            chunk3.layer = 10;
            ModAPI.CreateParticleEffect("BloodExplosion", chunk3.transform.position);
            chunk3.transform.localScale *= 0.6f;
            chunk3.AddComponent<DebrisComponent>();
            chunk3.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Human");
                        chunk3.transform.position = transform.position;
                            chunk3.gameObject.GetComponent<SpriteRenderer>().sprite = Mod.chunk;
                        var number2222223 = rand.Next(2);
                        if (number2222223 == 1)
                        {
                            chunk3.GetComponent<Rigidbody2D>().angularVelocity = UnityEngine.Random.value * 8f;
                        chunk3.GetComponent<Rigidbody2D>().velocity = new Vector2(UnityEngine.Random.value * 8f, UnityEngine.Random.value * 8f); 
                        }
                        else
                        {
                            chunk3.GetComponent<Rigidbody2D>().angularVelocity = -UnityEngine.Random.value * 8f;
                        chunk3.GetComponent<Rigidbody2D>().velocity = new Vector2(-UnityEngine.Random.value * 8f, -UnityEngine.Random.value * 8f); 
                        }
                        chunk3.gameObject.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
                        chunk3.FixColliders();
                        GameObject chunk4 = GameObject.Instantiate(ModAPI.FindSpawnable("Brick").Prefab);
            chunk4.layer = 10;
            ModAPI.CreateParticleEffect("BloodExplosion", chunk4.transform.position);
            chunk4.transform.localScale *= 0.6f;
            chunk4.AddComponent<DebrisComponent>();
            chunk4.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Human");
                        chunk4.transform.position = transform.position;
                            chunk4.gameObject.GetComponent<SpriteRenderer>().sprite = Mod.chunk;
                        var number22222223 = rand.Next(2);
                        if (number22222223 == 1)
                        {
                            chunk4.GetComponent<Rigidbody2D>().angularVelocity = UnityEngine.Random.value * 8f;
                        chunk4.GetComponent<Rigidbody2D>().velocity = new Vector2(UnityEngine.Random.value * 8f, UnityEngine.Random.value * 8f); 
                        }
                        else
                        {
                            chunk4.GetComponent<Rigidbody2D>().angularVelocity = -UnityEngine.Random.value * 8f;
                        chunk4.GetComponent<Rigidbody2D>().velocity = new Vector2(-UnityEngine.Random.value * 8f, -UnityEngine.Random.value * 8f); 
                        }
                        chunk4.gameObject.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
                        chunk4.FixColliders();
                        GameObject chunk5 = GameObject.Instantiate(ModAPI.FindSpawnable("Brick").Prefab);
            chunk5.layer = 10;
            ModAPI.CreateParticleEffect("BloodExplosion", chunk5.transform.position);
            chunk5.transform.localScale *= 0.4f;
            chunk5.AddComponent<DebrisComponent>();
            chunk5.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Human");
                        chunk5.transform.position = transform.position;
                            chunk5.gameObject.GetComponent<SpriteRenderer>().sprite = Mod.chunk;
                        var number222222223 = rand.Next(2);
                        if (number222222223 == 1)
                        {
                            chunk5.GetComponent<Rigidbody2D>().angularVelocity = UnityEngine.Random.value * 8f;
                        chunk5.GetComponent<Rigidbody2D>().velocity = new Vector2(UnityEngine.Random.value * 8f, UnityEngine.Random.value * 8f); 
                        }
                        else
                        {
                            chunk5.GetComponent<Rigidbody2D>().angularVelocity = -UnityEngine.Random.value * 8f;
                        chunk5.GetComponent<Rigidbody2D>().velocity = new Vector2(-UnityEngine.Random.value * 8f, -UnityEngine.Random.value * 8f); 
                        }
                        chunk5.gameObject.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
                        chunk5.FixColliders();
                ModAPI.CreateParticleEffect("BloodExplosion", transform.position);
                ModAPI.CreateParticleEffect("BloodExplosion", transform.position);
                ModAPI.CreateParticleEffect("BloodExplosion", transform.position);
                CameraShakeBehaviour.main.Shake(2f * 6f, transform.position);
                        gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
        }

        public void Update()
        {
            if (!Ejected)
            {
            if (gameObject.GetComponent<SkinMaterialHandler>().currentDamagePointCount > 8 && gameObject.GetComponent<LimbBehaviour>().Health == 0 || gameObject.GetComponent<SkinMaterialHandler>().currentDamagePointCount > 8 && gameObject.GetComponent<LimbBehaviour>().Health < 0)
            {
                Ejected = true;
                Splat();
            }
            }
        }
    }
    public class ChestSplatter : MonoBehaviour
    {
        public bool Ejected = false;

        public void Splat()
        {
            GameObject BrainMatter = GameObject.Instantiate(ModAPI.FindSpawnable("Pumpkin").Prefab.GetComponent<DestroyableBehaviour>().DebrisPrefab.gameObject.transform.Find("chunks").gameObject);
            BrainMatter.gameObject.transform.position = transform.position;
            BrainMatter.gameObject.GetComponent<ParticleSystem>().startColor = new Color(0.5f, 0.2f, 0.2f, 1f); 
            GameObject BrainMatter4 = GameObject.Instantiate(ModAPI.FindSpawnable("Pumpkin").Prefab.GetComponent<DestroyableBehaviour>().DebrisPrefab.gameObject.transform.Find("chunks").gameObject);
            BrainMatter4.gameObject.transform.position = transform.position;
            BrainMatter4.gameObject.GetComponent<ParticleSystem>().startColor = new Color(0.6f, 0f, 0.2f, 1f);
            System.Random rand = new System.Random();
            var number32 = rand.Next(2);
                        if (number32 == 1)
                        {
                            GameObject peter = GameObject.Instantiate(ModAPI.FindSpawnable("Rod").Prefab);
                            peter.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Human");
            peter.layer = 9;
            peter.transform.localScale *= 1.2f;
                        peter.transform.position = transform.position;
                            peter.gameObject.GetComponent<SpriteRenderer>().sprite = Mod.peter;
                        var numberaf2 = rand.Next(2);
                        if (numberaf2 == 1)
                        {
                            peter.GetComponent<Rigidbody2D>().angularVelocity = UnityEngine.Random.value * 8f;
                        peter.GetComponent<Rigidbody2D>().velocity = new Vector2(UnityEngine.Random.value * 8f, UnityEngine.Random.value * 8f); 
                        }
                        else
                        {
                            peter.GetComponent<Rigidbody2D>().angularVelocity = -UnityEngine.Random.value * 8f;
                        peter.GetComponent<Rigidbody2D>().velocity = new Vector2(-UnityEngine.Random.value * 8f, -UnityEngine.Random.value * 8f); 
                        }
                        peter.gameObject.GetComponent<SpriteRenderer>().sortingLayerName = "Bottom";
                        ModAPI.CreateParticleEffect("BloodExplosion", peter.transform.position);
                        peter.gameObject.AddComponent<Heart>();
                        peter.FixColliders();
                        foreach (var Limbs in transform.root.gameObject.GetComponent<PersonBehaviour>().Limbs)
                        {
                          var DontCollideWithUser = Limbs.gameObject.AddComponent<NoCollide>();
                          DontCollideWithUser.NoCollideSetA = peter.gameObject.transform.root.gameObject.GetComponentsInChildren<Collider2D>();
                          DontCollideWithUser.NoCollideSetB = Limbs.gameObject.GetComponentsInChildren<Collider2D>();
                        }
                        }
                        var number33322 = rand.Next(3);
                        if (number33322 == 1)
                        {
                            GameObject spine = GameObject.Instantiate(ModAPI.FindSpawnable("spineobject").Prefab);
                            CatalogBehaviour.PerformMod(ModAPI.FindSpawnable("spineobject"), spine);
                            spine.transform.position = transform.position;
                        }
                        var number322 = rand.Next(2);
                        if (number322 == 1)
                        {
                            GameObject lung = GameObject.Instantiate(ModAPI.FindSpawnable("Rod").Prefab);
                            lung.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Human");
            lung.layer = 9;
                        lung.transform.position = transform.position;
                            lung.gameObject.GetComponent<SpriteRenderer>().sprite = Mod.lung;
                            lung.transform.localScale *= 0.4f;
                        var numberaf2 = rand.Next(3);
                        if (numberaf2 == 1)
                        {
                            lung.GetComponent<Rigidbody2D>().angularVelocity = UnityEngine.Random.value * 8f;
                        lung.GetComponent<Rigidbody2D>().velocity = new Vector2(UnityEngine.Random.value * 8f, UnityEngine.Random.value * 8f); 
                        }
                        else
                        {
                            lung.GetComponent<Rigidbody2D>().angularVelocity = -UnityEngine.Random.value * 8f;
                        lung.GetComponent<Rigidbody2D>().velocity = new Vector2(-UnityEngine.Random.value * 8f, -UnityEngine.Random.value * 8f); 
                        }
                        lung.gameObject.GetComponent<SpriteRenderer>().sortingLayerName = "Bottom";
                        ModAPI.CreateParticleEffect("BloodExplosion", lung.transform.position);
                        lung.AddComponent<DebrisComponent>();
                        lung.FixColliders();
                        foreach (var Limbs in transform.root.gameObject.GetComponent<PersonBehaviour>().Limbs)
                        {
                          var DontCollideWithUser = Limbs.gameObject.AddComponent<NoCollide>();
                          DontCollideWithUser.NoCollideSetA = lung.gameObject.transform.root.gameObject.GetComponentsInChildren<Collider2D>();
                          DontCollideWithUser.NoCollideSetB = Limbs.gameObject.GetComponentsInChildren<Collider2D>();
                        }
                        }
                        var number232 = rand.Next(2);
                        if (number232 == 1)
                        {
                            GameObject stewie = GameObject.Instantiate(ModAPI.FindSpawnable("Rod").Prefab);
                            stewie.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Human");
            stewie.layer = 9;
                        stewie.transform.position = transform.position;
                            stewie.gameObject.GetComponent<SpriteRenderer>().sprite = Mod.stewie;
                            stewie.AddComponent<DebrisComponent>();
                        var numberaf2 = rand.Next(2);
                        if (numberaf2 == 1)
                        {
                            stewie.GetComponent<Rigidbody2D>().angularVelocity = UnityEngine.Random.value * 8f;
                        stewie.GetComponent<Rigidbody2D>().velocity = new Vector2(UnityEngine.Random.value * 8f, UnityEngine.Random.value * 8f); 
                        }
                        else
                        {
                            stewie.GetComponent<Rigidbody2D>().angularVelocity = -UnityEngine.Random.value * 8f;
                        stewie.GetComponent<Rigidbody2D>().velocity = new Vector2(-UnityEngine.Random.value * 8f, -UnityEngine.Random.value * 8f); 
                        }
                        stewie.gameObject.GetComponent<SpriteRenderer>().sortingLayerName = "Bottom";
                        ModAPI.CreateParticleEffect("BloodExplosion", stewie.transform.position);
                        stewie.transform.localScale *= 0.4f;
                        stewie.FixColliders();
                        foreach (var Limbs in transform.root.gameObject.GetComponent<PersonBehaviour>().Limbs)
                        {
                          var DontCollideWithUser = Limbs.gameObject.AddComponent<NoCollide>();
                          DontCollideWithUser.NoCollideSetA = stewie.gameObject.transform.root.gameObject.GetComponentsInChildren<Collider2D>();
                          DontCollideWithUser.NoCollideSetB = Limbs.gameObject.GetComponentsInChildren<Collider2D>();
                        }
                        }
        GameObject skullchunk = GameObject.Instantiate(ModAPI.FindSpawnable("Brick").Prefab);
            skullchunk.layer = 9;
            skullchunk.transform.localScale *= 1.2f;
                        skullchunk.transform.position = transform.position;
                            skullchunk.gameObject.GetComponent<SpriteRenderer>().sprite = Mod.rib1;
                        var number2 = rand.Next(2);
                        if (number2 == 1)
                        {
                            skullchunk.GetComponent<Rigidbody2D>().angularVelocity = UnityEngine.Random.value * 8f;
                        skullchunk.GetComponent<Rigidbody2D>().velocity = new Vector2(UnityEngine.Random.value * 8f, UnityEngine.Random.value * 8f); 
                        }
                        else
                        {
                            skullchunk.GetComponent<Rigidbody2D>().angularVelocity = -UnityEngine.Random.value * 8f;
                        skullchunk.GetComponent<Rigidbody2D>().velocity = new Vector2(-UnityEngine.Random.value * 8f, -UnityEngine.Random.value * 8f); 
                        }
                        skullchunk.gameObject.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
                        skullchunk.AddComponent<DebrisComponent>();
                        ModAPI.CreateParticleEffect("BloodExplosion", skullchunk.transform.position);
                        skullchunk.FixColliders();
                        foreach (var Limbs in transform.root.gameObject.GetComponent<PersonBehaviour>().Limbs)
                        {
                          var DontCollideWithUser = Limbs.gameObject.AddComponent<NoCollide>();
                          DontCollideWithUser.NoCollideSetA = skullchunk.gameObject.transform.root.gameObject.GetComponentsInChildren<Collider2D>();
                          DontCollideWithUser.NoCollideSetB = Limbs.gameObject.GetComponentsInChildren<Collider2D>();
                        }
                        GameObject skullcunk = GameObject.Instantiate(ModAPI.FindSpawnable("Brick").Prefab);
            skullcunk.layer = 9;
            skullcunk.transform.localScale *= 1.3f;
            skullcunk.AddComponent<DebrisComponent>();
                        skullcunk.transform.position = transform.position;
                            skullcunk.gameObject.GetComponent<SpriteRenderer>().sprite = Mod.rib2;
                        var numberf2 = rand.Next(2);
                        if (numberf2 == 1)
                        {
                            skullcunk.GetComponent<Rigidbody2D>().angularVelocity = UnityEngine.Random.value * 8f;
                        skullcunk.GetComponent<Rigidbody2D>().velocity = new Vector2(UnityEngine.Random.value * 8f, UnityEngine.Random.value * 8f); 
                        }
                        else
                        {
                            skullcunk.GetComponent<Rigidbody2D>().angularVelocity = -UnityEngine.Random.value * 8f;
                        skullcunk.GetComponent<Rigidbody2D>().velocity = new Vector2(-UnityEngine.Random.value * 8f, -UnityEngine.Random.value * 8f); 
                        }
                        skullcunk.gameObject.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
                        ModAPI.CreateParticleEffect("BloodExplosion", skullcunk.transform.position);
                        skullcunk.FixColliders();
                        foreach (var Limbs in transform.root.gameObject.GetComponent<PersonBehaviour>().Limbs)
                        {
                          var DontCollideWithUser = Limbs.gameObject.AddComponent<NoCollide>();
                          DontCollideWithUser.NoCollideSetA = skullchunk.gameObject.transform.root.gameObject.GetComponentsInChildren<Collider2D>();
                          DontCollideWithUser.NoCollideSetB = Limbs.gameObject.GetComponentsInChildren<Collider2D>();
                        }
                        GameObject skullcunk2 = GameObject.Instantiate(ModAPI.FindSpawnable("Brick").Prefab);
            skullcunk2.layer = 9;
            skullcunk2.transform.localScale *= 1.3f;
            skullcunk2.AddComponent<DebrisComponent>();
                        skullcunk2.transform.position = transform.position;
                            skullcunk2.gameObject.GetComponent<SpriteRenderer>().sprite = Mod.rib3;
                        var numbergf2 = rand.Next(2);
                        if (numbergf2 == 1)
                        {
                            skullcunk2.GetComponent<Rigidbody2D>().angularVelocity = UnityEngine.Random.value * 8f;
                        skullcunk2.GetComponent<Rigidbody2D>().velocity = new Vector2(UnityEngine.Random.value * 8f, UnityEngine.Random.value * 8f); 
                        }
                        else
                        {
                            skullcunk2.GetComponent<Rigidbody2D>().angularVelocity = -UnityEngine.Random.value * 8f;
                        skullcunk2.GetComponent<Rigidbody2D>().velocity = new Vector2(-UnityEngine.Random.value * 8f, -UnityEngine.Random.value * 8f); 
                        }
                        skullcunk2.gameObject.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
                        ModAPI.CreateParticleEffect("BloodExplosion", skullcunk2.transform.position);
                        skullcunk2.FixColliders();
                        foreach (var Limbs in transform.root.gameObject.GetComponent<PersonBehaviour>().Limbs)
                        {
                          var DontCollideWithUser = Limbs.gameObject.AddComponent<NoCollide>();
                          DontCollideWithUser.NoCollideSetA = skullcunk2.gameObject.transform.root.gameObject.GetComponentsInChildren<Collider2D>();
                          DontCollideWithUser.NoCollideSetB = Limbs.gameObject.GetComponentsInChildren<Collider2D>();
                        }
                        var DontCollideW2ithUser = skullcunk2.gameObject.AddComponent<NoCollide>();
                          DontCollideW2ithUser.NoCollideSetA = skullcunk.gameObject.transform.root.gameObject.GetComponentsInChildren<Collider2D>();
                          DontCollideW2ithUser.NoCollideSetB = skullcunk2.gameObject.GetComponentsInChildren<Collider2D>();
                          var DontCollideWi2thUser = skullcunk2.gameObject.AddComponent<NoCollide>();
                          DontCollideWi2thUser.NoCollideSetA = skullchunk.gameObject.transform.root.gameObject.GetComponentsInChildren<Collider2D>();
                          DontCollideWi2thUser.NoCollideSetB = skullcunk2.gameObject.GetComponentsInChildren<Collider2D>();
                          var DontColdlideWithUser = skullcunk.gameObject.AddComponent<NoCollide>();
                          DontColdlideWithUser.NoCollideSetA = skullchunk.gameObject.transform.root.gameObject.GetComponentsInChildren<Collider2D>();
                          DontColdlideWithUser.NoCollideSetB = skullcunk.gameObject.GetComponentsInChildren<Collider2D>();
                        GameObject skullchunk2 = GameObject.Instantiate(ModAPI.FindSpawnable("Brick").Prefab);
            skullchunk2.layer = 10;
            skullchunk2.AddComponent<DebrisComponent>();
            skullchunk2.transform.localScale *= 0.5f;
                        skullchunk2.transform.position = transform.position;
                        ModAPI.CreateParticleEffect("BloodExplosion", skullchunk2.transform.position);
                            skullchunk2.gameObject.GetComponent<SpriteRenderer>().sprite = Mod.skull3;
                        var number23 = rand.Next(2);
                        if (number23 == 1)
                        {
                            skullchunk2.GetComponent<Rigidbody2D>().angularVelocity = UnityEngine.Random.value * 8f;
                        skullchunk2.GetComponent<Rigidbody2D>().velocity = new Vector2(UnityEngine.Random.value * 8f, UnityEngine.Random.value * 8f); 
                        }
                        else
                        {
                            skullchunk2.GetComponent<Rigidbody2D>().angularVelocity = -UnityEngine.Random.value * 8f;
                        skullchunk2.GetComponent<Rigidbody2D>().velocity = new Vector2(-UnityEngine.Random.value * 8f, -UnityEngine.Random.value * 8f); 
                        }
                        skullchunk2.gameObject.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
                        skullchunk2.FixColliders();
                        GameObject skullchunk3 = GameObject.Instantiate(ModAPI.FindSpawnable("Brick").Prefab);
            skullchunk3.layer = 10;
            skullchunk3.AddComponent<DebrisComponent>();
            skullchunk3.transform.localScale *= 0.5f;
            ModAPI.CreateParticleEffect("BloodExplosion", skullchunk3.transform.position);
                        skullchunk3.transform.position = transform.position;
                            skullchunk3.gameObject.GetComponent<SpriteRenderer>().sprite = Mod.skull3;
                        var number223 = rand.Next(2);
                        if (number223 == 1)
                        {
                            skullchunk3.GetComponent<Rigidbody2D>().angularVelocity = UnityEngine.Random.value * 8f;
                        skullchunk3.GetComponent<Rigidbody2D>().velocity = new Vector2(UnityEngine.Random.value * 8f, UnityEngine.Random.value * 8f); 
                        }
                        else
                        {
                            skullchunk3.GetComponent<Rigidbody2D>().angularVelocity = -UnityEngine.Random.value * 8f;
                        skullchunk3.GetComponent<Rigidbody2D>().velocity = new Vector2(-UnityEngine.Random.value * 8f, -UnityEngine.Random.value * 8f); 
                        }
                        skullchunk3.gameObject.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
                        skullchunk3.FixColliders();
                        skullchunk3.gameObject.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
                        skullchunk3.FixColliders();
                        GameObject skullchunk4 = GameObject.Instantiate(ModAPI.FindSpawnable("Brick").Prefab);
            skullchunk4.layer = 10;
            ModAPI.CreateParticleEffect("BloodExplosion", skullchunk4.transform.position);
            skullchunk4.transform.localScale *= 0.4f;
            skullchunk4.AddComponent<DebrisComponent>();
                        skullchunk4.transform.position = transform.position;
                            skullchunk4.gameObject.GetComponent<SpriteRenderer>().sprite = Mod.skull3;
                        var number2223 = rand.Next(2);
                        if (number2223 == 1)
                        {
                            skullchunk4.GetComponent<Rigidbody2D>().angularVelocity = UnityEngine.Random.value * 8f;
                        skullchunk4.GetComponent<Rigidbody2D>().velocity = new Vector2(UnityEngine.Random.value * 8f, UnityEngine.Random.value * 8f); 
                        }
                        else
                        {
                            skullchunk4.GetComponent<Rigidbody2D>().angularVelocity = -UnityEngine.Random.value * 8f;
                        skullchunk4.GetComponent<Rigidbody2D>().velocity = new Vector2(-UnityEngine.Random.value * 8f, -UnityEngine.Random.value * 8f); 
                        }
                        skullchunk4.gameObject.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
                        skullchunk4.FixColliders();
                ModAPI.CreateParticleEffect("BloodExplosion", transform.position);
                ModAPI.CreateParticleEffect("BloodExplosion", transform.position);
                ModAPI.CreateParticleEffect("BloodExplosion", transform.position);
                CameraShakeBehaviour.main.Shake(2f * 6f, transform.position);
                        gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
        }

        public void Update()
        {
            if (!Ejected)
            {
            if (gameObject.GetComponent<SkinMaterialHandler>().currentDamagePointCount > 12 && gameObject.GetComponent<LimbBehaviour>().Health == 0 || gameObject.GetComponent<SkinMaterialHandler>().currentDamagePointCount > 12 && gameObject.GetComponent<LimbBehaviour>().Health < 0)
            {
                Ejected = true;
                Splat();
            }
            }
        }
    }
    public class MiddleSplatter : MonoBehaviour
    {
        public bool Ejected = false;

        public void Splat()
        {
            GameObject BrainMatter = GameObject.Instantiate(ModAPI.FindSpawnable("Pumpkin").Prefab.GetComponent<DestroyableBehaviour>().DebrisPrefab.gameObject.transform.Find("chunks").gameObject);
            BrainMatter.gameObject.transform.position = transform.position;
            BrainMatter.gameObject.GetComponent<ParticleSystem>().startColor = new Color(0.5f, 0.2f, 0.2f, 1f); 
            GameObject BrainMatter4 = GameObject.Instantiate(ModAPI.FindSpawnable("Pumpkin").Prefab.GetComponent<DestroyableBehaviour>().DebrisPrefab.gameObject.transform.Find("chunks").gameObject);
            BrainMatter4.gameObject.transform.position = transform.position;
            BrainMatter4.gameObject.GetComponent<ParticleSystem>().startColor = new Color(0.6f, 0f, 0.2f, 1f);
            System.Random rand = new System.Random();
            var number32 = rand.Next(2);
                        if (number32 == 1)
                        {
                            GameObject liver1 = GameObject.Instantiate(ModAPI.FindSpawnable("Rod").Prefab);
                            liver1.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Human");
            liver1.layer = 9;
            liver1.transform.localScale *= 1.1f;
                        liver1.transform.position = transform.position;
                            liver1.gameObject.GetComponent<SpriteRenderer>().sprite = Mod.liver1;
                            liver1.AddComponent<DebrisComponent>();
                        var numberaf2 = rand.Next(2);
                        if (numberaf2 == 1)
                        {
                            liver1.GetComponent<Rigidbody2D>().angularVelocity = UnityEngine.Random.value * 8f;
                        liver1.GetComponent<Rigidbody2D>().velocity = new Vector2(UnityEngine.Random.value * 8f, UnityEngine.Random.value * 8f); 
                        }
                        else
                        {
                            liver1.GetComponent<Rigidbody2D>().angularVelocity = -UnityEngine.Random.value * 8f;
                        liver1.GetComponent<Rigidbody2D>().velocity = new Vector2(-UnityEngine.Random.value * 8f, -UnityEngine.Random.value * 8f); 
                        }
                        liver1.gameObject.GetComponent<SpriteRenderer>().sortingLayerName = "Bottom";
                        ModAPI.CreateParticleEffect("BloodExplosion", liver1.transform.position);
                        liver1.FixColliders();
                        foreach (var Limbs in transform.root.gameObject.GetComponent<PersonBehaviour>().Limbs)
                        {
                          var DontCollideWithUser = Limbs.gameObject.AddComponent<NoCollide>();
                          DontCollideWithUser.NoCollideSetA = liver1.gameObject.transform.root.gameObject.GetComponentsInChildren<Collider2D>();
                          DontCollideWithUser.NoCollideSetB = Limbs.gameObject.GetComponentsInChildren<Collider2D>();
                        }
                        }
                        var number322 = rand.Next(2);
                        if (number322 == 1)
                        {
                            GameObject liver2 = GameObject.Instantiate(ModAPI.FindSpawnable("Rod").Prefab);
                            liver2.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Human");
            liver2.layer = 9;
                        liver2.transform.position = transform.position;
                            liver2.gameObject.GetComponent<SpriteRenderer>().sprite = Mod.liver2;
                            liver2.transform.localScale *= 0.9f;
                            liver2.AddComponent<DebrisComponent>();
                        var numberaf2 = rand.Next(3);
                        if (numberaf2 == 1)
                        {
                            liver2.GetComponent<Rigidbody2D>().angularVelocity = UnityEngine.Random.value * 8f;
                        liver2.GetComponent<Rigidbody2D>().velocity = new Vector2(UnityEngine.Random.value * 8f, UnityEngine.Random.value * 8f); 
                        }
                        else
                        {
                            liver2.GetComponent<Rigidbody2D>().angularVelocity = -UnityEngine.Random.value * 8f;
                        liver2.GetComponent<Rigidbody2D>().velocity = new Vector2(-UnityEngine.Random.value * 8f, -UnityEngine.Random.value * 8f); 
                        }
                        liver2.gameObject.GetComponent<SpriteRenderer>().sortingLayerName = "Bottom";
                        ModAPI.CreateParticleEffect("BloodExplosion", liver2.transform.position);
                        liver2.FixColliders();
                        foreach (var Limbs in transform.root.gameObject.GetComponent<PersonBehaviour>().Limbs)
                        {
                          var DontCollideWithUser = Limbs.gameObject.AddComponent<NoCollide>();
                          DontCollideWithUser.NoCollideSetA = liver2.gameObject.transform.root.gameObject.GetComponentsInChildren<Collider2D>();
                          DontCollideWithUser.NoCollideSetB = Limbs.gameObject.GetComponentsInChildren<Collider2D>();
                        }
                        }
                        var number232 = rand.Next(2);
                        if (number232 == 1)
                        {
                            GameObject liver3 = GameObject.Instantiate(ModAPI.FindSpawnable("Rod").Prefab);
                            liver3.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Human");
            liver3.layer = 9;
                        liver3.transform.position = transform.position;
                            liver3.gameObject.GetComponent<SpriteRenderer>().sprite = Mod.liver3;
                            liver3.AddComponent<DebrisComponent>();
                        var numberaf2 = rand.Next(2);
                        if (numberaf2 == 1)
                        {
                            liver3.GetComponent<Rigidbody2D>().angularVelocity = UnityEngine.Random.value * 8f;
                        liver3.GetComponent<Rigidbody2D>().velocity = new Vector2(UnityEngine.Random.value * 8f, UnityEngine.Random.value * 8f); 
                        }
                        else
                        {
                            liver3.GetComponent<Rigidbody2D>().angularVelocity = -UnityEngine.Random.value * 8f;
                        liver3.GetComponent<Rigidbody2D>().velocity = new Vector2(-UnityEngine.Random.value * 8f, -UnityEngine.Random.value * 8f); 
                        }
                        liver3.gameObject.GetComponent<SpriteRenderer>().sortingLayerName = "Bottom";
                        ModAPI.CreateParticleEffect("BloodExplosion", liver3.transform.position);
                        liver3.transform.localScale *= 1f;
                        liver3.FixColliders();
                        foreach (var Limbs in transform.root.gameObject.GetComponent<PersonBehaviour>().Limbs)
                        {
                          var DontCollideWithUser = Limbs.gameObject.AddComponent<NoCollide>();
                          DontCollideWithUser.NoCollideSetA = liver3.gameObject.transform.root.gameObject.GetComponentsInChildren<Collider2D>();
                          DontCollideWithUser.NoCollideSetB = Limbs.gameObject.GetComponentsInChildren<Collider2D>();
                        }
                        }
                        var number342 = rand.Next(2);
                        if (number342 == 1)
                        {
                            GameObject joe1 = GameObject.Instantiate(ModAPI.FindSpawnable("Rod").Prefab);
                            joe1.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Human");
            joe1.layer = 9;
            joe1.transform.localScale *= 0.7f;
                        joe1.transform.position = transform.position;
                            joe1.gameObject.GetComponent<SpriteRenderer>().sprite = Mod.joe1;
                            joe1.AddComponent<DebrisComponent>();
                        var numbera1f2 = rand.Next(2);
                        if (numbera1f2 == 1)
                        {
                            joe1.GetComponent<Rigidbody2D>().angularVelocity = UnityEngine.Random.value * 8f;
                        joe1.GetComponent<Rigidbody2D>().velocity = new Vector2(UnityEngine.Random.value * 8f, UnityEngine.Random.value * 8f); 
                        }
                        else
                        {
                            joe1.GetComponent<Rigidbody2D>().angularVelocity = -UnityEngine.Random.value * 8f;
                        joe1.GetComponent<Rigidbody2D>().velocity = new Vector2(-UnityEngine.Random.value * 8f, -UnityEngine.Random.value * 8f); 
                        }
                        joe1.gameObject.GetComponent<SpriteRenderer>().sortingLayerName = "Bottom";
                        ModAPI.CreateParticleEffect("BloodExplosion", joe1.transform.position);
                        joe1.FixColliders();
                        foreach (var Limbs in transform.root.gameObject.GetComponent<PersonBehaviour>().Limbs)
                        {
                          var DontCollideWithUser = Limbs.gameObject.AddComponent<NoCollide>();
                          DontCollideWithUser.NoCollideSetA = joe1.gameObject.transform.root.gameObject.GetComponentsInChildren<Collider2D>();
                          DontCollideWithUser.NoCollideSetB = Limbs.gameObject.GetComponentsInChildren<Collider2D>();
                        }
                        }
                        var number1322 = rand.Next(2);
                        if (number1322 == 1)
                        {
                            GameObject joe2 = GameObject.Instantiate(ModAPI.FindSpawnable("Rod").Prefab);
                            joe2.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Human");
            joe2.layer = 9;
                        joe2.transform.position = transform.position;
                            joe2.gameObject.GetComponent<SpriteRenderer>().sprite = Mod.joe2;
                            joe2.transform.localScale *= 0.5f;
                            joe2.AddComponent<DebrisComponent>();
                        var number3af2 = rand.Next(3);
                        if (number3af2 == 1)
                        {
                            joe2.GetComponent<Rigidbody2D>().angularVelocity = UnityEngine.Random.value * 8f;
                        joe2.GetComponent<Rigidbody2D>().velocity = new Vector2(UnityEngine.Random.value * 8f, UnityEngine.Random.value * 8f); 
                        }
                        else
                        {
                            joe2.GetComponent<Rigidbody2D>().angularVelocity = -UnityEngine.Random.value * 8f;
                        joe2.GetComponent<Rigidbody2D>().velocity = new Vector2(-UnityEngine.Random.value * 8f, -UnityEngine.Random.value * 8f); 
                        }
                        joe2.gameObject.GetComponent<SpriteRenderer>().sortingLayerName = "Bottom";
                        ModAPI.CreateParticleEffect("BloodExplosion", joe2.transform.position);
                        joe2.FixColliders();
                        foreach (var Limbs in transform.root.gameObject.GetComponent<PersonBehaviour>().Limbs)
                        {
                          var DontCollideWithUser = Limbs.gameObject.AddComponent<NoCollide>();
                          DontCollideWithUser.NoCollideSetA = joe2.gameObject.transform.root.gameObject.GetComponentsInChildren<Collider2D>();
                          DontCollideWithUser.NoCollideSetB = Limbs.gameObject.GetComponentsInChildren<Collider2D>();
                        }
                        }
                        var number2432 = rand.Next(2);
                        if (number2432 == 1)
                        {
                            GameObject joe3 = GameObject.Instantiate(ModAPI.FindSpawnable("Rod").Prefab);
                            joe3.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Human");
            joe3.layer = 9;
                        joe3.transform.position = transform.position;
                            joe3.gameObject.GetComponent<SpriteRenderer>().sprite = Mod.joe3;
                            joe3.AddComponent<DebrisComponent>();
                            joe3.transform.localScale *= 0.5f;
                        var number9af2 = rand.Next(2);
                        if (number9af2 == 1)
                        {
                            joe3.GetComponent<Rigidbody2D>().angularVelocity = UnityEngine.Random.value * 8f;
                        joe3.GetComponent<Rigidbody2D>().velocity = new Vector2(UnityEngine.Random.value * 8f, UnityEngine.Random.value * 8f); 
                        }
                        else
                        {
                            joe3.GetComponent<Rigidbody2D>().angularVelocity = -UnityEngine.Random.value * 8f;
                        joe3.GetComponent<Rigidbody2D>().velocity = new Vector2(-UnityEngine.Random.value * 8f, -UnityEngine.Random.value * 8f); 
                        }
                        joe3.gameObject.GetComponent<SpriteRenderer>().sortingLayerName = "Bottom";
                        ModAPI.CreateParticleEffect("BloodExplosion", joe3.transform.position);
                        joe3.transform.localScale *= 1f;
                        joe3.FixColliders();
                        foreach (var Limbs in transform.root.gameObject.GetComponent<PersonBehaviour>().Limbs)
                        {
                          var DontCollideWithUser = Limbs.gameObject.AddComponent<NoCollide>();
                          DontCollideWithUser.NoCollideSetA = joe3.gameObject.transform.root.gameObject.GetComponentsInChildren<Collider2D>();
                          DontCollideWithUser.NoCollideSetB = Limbs.gameObject.GetComponentsInChildren<Collider2D>();
                        }
                        }
        GameObject skullchunk = GameObject.Instantiate(ModAPI.FindSpawnable("Brick").Prefab);
            skullchunk.layer = 9;
            skullchunk.transform.localScale *= 1.2f;
                        skullchunk.transform.position = transform.position;
                            skullchunk.gameObject.GetComponent<SpriteRenderer>().sprite = Mod.mid1;
                            skullchunk.AddComponent<DebrisComponent>();
                        var number2 = rand.Next(2);
                        if (number2 == 1)
                        {
                            skullchunk.GetComponent<Rigidbody2D>().angularVelocity = UnityEngine.Random.value * 8f;
                        skullchunk.GetComponent<Rigidbody2D>().velocity = new Vector2(UnityEngine.Random.value * 8f, UnityEngine.Random.value * 8f); 
                        }
                        else
                        {
                            skullchunk.GetComponent<Rigidbody2D>().angularVelocity = -UnityEngine.Random.value * 8f;
                        skullchunk.GetComponent<Rigidbody2D>().velocity = new Vector2(-UnityEngine.Random.value * 8f, -UnityEngine.Random.value * 8f); 
                        }
                        skullchunk.gameObject.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
                        ModAPI.CreateParticleEffect("BloodExplosion", skullchunk.transform.position);
                        skullchunk.FixColliders();
                        foreach (var Limbs in transform.root.gameObject.GetComponent<PersonBehaviour>().Limbs)
                        {
                          var DontCollideWithUser = Limbs.gameObject.AddComponent<NoCollide>();
                          DontCollideWithUser.NoCollideSetA = skullchunk.gameObject.transform.root.gameObject.GetComponentsInChildren<Collider2D>();
                          DontCollideWithUser.NoCollideSetB = Limbs.gameObject.GetComponentsInChildren<Collider2D>();
                        }
                        GameObject skullcunk = GameObject.Instantiate(ModAPI.FindSpawnable("Brick").Prefab);
            skullcunk.layer = 9;
            skullcunk.transform.localScale *= 1.3f;
            skullcunk.AddComponent<DebrisComponent>();
                        skullcunk.transform.position = transform.position;
                            skullcunk.gameObject.GetComponent<SpriteRenderer>().sprite = Mod.mid2;
                        var numberf2 = rand.Next(2);
                        if (numberf2 == 1)
                        {
                            skullcunk.GetComponent<Rigidbody2D>().angularVelocity = UnityEngine.Random.value * 8f;
                        skullcunk.GetComponent<Rigidbody2D>().velocity = new Vector2(UnityEngine.Random.value * 8f, UnityEngine.Random.value * 8f); 
                        }
                        else
                        {
                            skullcunk.GetComponent<Rigidbody2D>().angularVelocity = -UnityEngine.Random.value * 8f;
                        skullcunk.GetComponent<Rigidbody2D>().velocity = new Vector2(-UnityEngine.Random.value * 8f, -UnityEngine.Random.value * 8f); 
                        }
                        skullcunk.gameObject.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
                        ModAPI.CreateParticleEffect("BloodExplosion", skullcunk.transform.position);
                        skullcunk.FixColliders();
                        foreach (var Limbs in transform.root.gameObject.GetComponent<PersonBehaviour>().Limbs)
                        {
                          var DontCollideWithUser = Limbs.gameObject.AddComponent<NoCollide>();
                          DontCollideWithUser.NoCollideSetA = skullchunk.gameObject.transform.root.gameObject.GetComponentsInChildren<Collider2D>();
                          DontCollideWithUser.NoCollideSetB = Limbs.gameObject.GetComponentsInChildren<Collider2D>();
                        }
                        GameObject skullcunk2 = GameObject.Instantiate(ModAPI.FindSpawnable("Brick").Prefab);
            skullcunk2.layer = 9;
            skullcunk2.AddComponent<DebrisComponent>();
            skullcunk2.transform.localScale *= 1.3f;
                        skullcunk2.transform.position = transform.position;
                            skullcunk2.gameObject.GetComponent<SpriteRenderer>().sprite = Mod.mid3;
                        var numbergf2 = rand.Next(2);
                        if (numbergf2 == 1)
                        {
                            skullcunk2.GetComponent<Rigidbody2D>().angularVelocity = UnityEngine.Random.value * 8f;
                        skullcunk2.GetComponent<Rigidbody2D>().velocity = new Vector2(UnityEngine.Random.value * 8f, UnityEngine.Random.value * 8f); 
                        }
                        else
                        {
                            skullcunk2.GetComponent<Rigidbody2D>().angularVelocity = -UnityEngine.Random.value * 8f;
                        skullcunk2.GetComponent<Rigidbody2D>().velocity = new Vector2(-UnityEngine.Random.value * 8f, -UnityEngine.Random.value * 8f); 
                        }
                        skullcunk2.gameObject.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
                        ModAPI.CreateParticleEffect("BloodExplosion", skullcunk2.transform.position);
                        skullcunk2.FixColliders();
                        foreach (var Limbs in transform.root.gameObject.GetComponent<PersonBehaviour>().Limbs)
                        {
                          var DontCollideWithUser = Limbs.gameObject.AddComponent<NoCollide>();
                          DontCollideWithUser.NoCollideSetA = skullcunk2.gameObject.transform.root.gameObject.GetComponentsInChildren<Collider2D>();
                          DontCollideWithUser.NoCollideSetB = Limbs.gameObject.GetComponentsInChildren<Collider2D>();
                        }
                        var DontCollideW2ithUser = skullcunk2.gameObject.AddComponent<NoCollide>();
                          DontCollideW2ithUser.NoCollideSetA = skullcunk.gameObject.transform.root.gameObject.GetComponentsInChildren<Collider2D>();
                          DontCollideW2ithUser.NoCollideSetB = skullcunk2.gameObject.GetComponentsInChildren<Collider2D>();
                          var DontCollideWi2thUser = skullcunk2.gameObject.AddComponent<NoCollide>();
                          DontCollideWi2thUser.NoCollideSetA = skullchunk.gameObject.transform.root.gameObject.GetComponentsInChildren<Collider2D>();
                          DontCollideWi2thUser.NoCollideSetB = skullcunk2.gameObject.GetComponentsInChildren<Collider2D>();
                          var DontColdlideWithUser = skullcunk.gameObject.AddComponent<NoCollide>();
                          DontColdlideWithUser.NoCollideSetA = skullchunk.gameObject.transform.root.gameObject.GetComponentsInChildren<Collider2D>();
                          DontColdlideWithUser.NoCollideSetB = skullcunk.gameObject.GetComponentsInChildren<Collider2D>();
                        GameObject skullchunk2 = GameObject.Instantiate(ModAPI.FindSpawnable("Brick").Prefab);
            skullchunk2.layer = 10;
            skullchunk2.AddComponent<DebrisComponent>();
            skullchunk2.transform.localScale *= 0.5f;
                        skullchunk2.transform.position = transform.position;
                        ModAPI.CreateParticleEffect("BloodExplosion", skullchunk2.transform.position);
                            skullchunk2.gameObject.GetComponent<SpriteRenderer>().sprite = Mod.skull3;
                        var number23 = rand.Next(2);
                        if (number23 == 1)
                        {
                            skullchunk2.GetComponent<Rigidbody2D>().angularVelocity = UnityEngine.Random.value * 8f;
                        skullchunk2.GetComponent<Rigidbody2D>().velocity = new Vector2(UnityEngine.Random.value * 8f, UnityEngine.Random.value * 8f); 
                        }
                        else
                        {
                            skullchunk2.GetComponent<Rigidbody2D>().angularVelocity = -UnityEngine.Random.value * 8f;
                        skullchunk2.GetComponent<Rigidbody2D>().velocity = new Vector2(-UnityEngine.Random.value * 8f, -UnityEngine.Random.value * 8f); 
                        }
                        skullchunk2.gameObject.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
                        skullchunk2.FixColliders();
                        GameObject skullchunk3 = GameObject.Instantiate(ModAPI.FindSpawnable("Brick").Prefab);
            skullchunk3.layer = 10;
            skullchunk3.AddComponent<DebrisComponent>();
            skullchunk3.transform.localScale *= 0.5f;
            ModAPI.CreateParticleEffect("BloodExplosion", skullchunk3.transform.position);
                        skullchunk3.transform.position = transform.position;
                            skullchunk3.gameObject.GetComponent<SpriteRenderer>().sprite = Mod.skull3;
                        var number223 = rand.Next(2);
                        if (number223 == 1)
                        {
                            skullchunk3.GetComponent<Rigidbody2D>().angularVelocity = UnityEngine.Random.value * 8f;
                        skullchunk3.GetComponent<Rigidbody2D>().velocity = new Vector2(UnityEngine.Random.value * 8f, UnityEngine.Random.value * 8f); 
                        }
                        else
                        {
                            skullchunk3.GetComponent<Rigidbody2D>().angularVelocity = -UnityEngine.Random.value * 8f;
                        skullchunk3.GetComponent<Rigidbody2D>().velocity = new Vector2(-UnityEngine.Random.value * 8f, -UnityEngine.Random.value * 8f); 
                        }
                        skullchunk3.gameObject.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
                        skullchunk3.FixColliders();
                        skullchunk3.gameObject.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
                        skullchunk3.FixColliders();
                        GameObject skullchunk4 = GameObject.Instantiate(ModAPI.FindSpawnable("Brick").Prefab);
            skullchunk4.layer = 10;
            skullchunk4.AddComponent<DebrisComponent>();
            ModAPI.CreateParticleEffect("BloodExplosion", skullchunk4.transform.position);
            skullchunk4.transform.localScale *= 0.4f;
                        skullchunk4.transform.position = transform.position;
                            skullchunk4.gameObject.GetComponent<SpriteRenderer>().sprite = Mod.skull3;
                        var number2223 = rand.Next(2);
                        if (number2223 == 1)
                        {
                            skullchunk4.GetComponent<Rigidbody2D>().angularVelocity = UnityEngine.Random.value * 8f;
                        skullchunk4.GetComponent<Rigidbody2D>().velocity = new Vector2(UnityEngine.Random.value * 8f, UnityEngine.Random.value * 8f); 
                        }
                        else
                        {
                            skullchunk4.GetComponent<Rigidbody2D>().angularVelocity = -UnityEngine.Random.value * 8f;
                        skullchunk4.GetComponent<Rigidbody2D>().velocity = new Vector2(-UnityEngine.Random.value * 8f, -UnityEngine.Random.value * 8f); 
                        }
                        skullchunk4.gameObject.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
                        skullchunk4.FixColliders();
                ModAPI.CreateParticleEffect("BloodExplosion", transform.position);
                ModAPI.CreateParticleEffect("BloodExplosion", transform.position);
                ModAPI.CreateParticleEffect("BloodExplosion", transform.position);
                CameraShakeBehaviour.main.Shake(2f * 6f, transform.position);
                        gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
        }

        public void Update()
        {
            if (!Ejected)
            {
            if (gameObject.GetComponent<SkinMaterialHandler>().currentDamagePointCount > 12 && gameObject.GetComponent<LimbBehaviour>().Health == 0 || gameObject.GetComponent<SkinMaterialHandler>().currentDamagePointCount > 12 && gameObject.GetComponent<LimbBehaviour>().Health < 0)
            {
                Ejected = true;
                Splat();
            }
            }
        }
    }
    public class LowerSplatter : MonoBehaviour
    {
        public bool Ejected = false;

        public void Splat()
        {
            GameObject BrainMatter = GameObject.Instantiate(ModAPI.FindSpawnable("Pumpkin").Prefab.GetComponent<DestroyableBehaviour>().DebrisPrefab.gameObject.transform.Find("chunks").gameObject);
            BrainMatter.gameObject.transform.position = transform.position;
            BrainMatter.gameObject.GetComponent<ParticleSystem>().startColor = new Color(0.5f, 0.2f, 0.2f, 1f); 
            GameObject BrainMatter4 = GameObject.Instantiate(ModAPI.FindSpawnable("Pumpkin").Prefab.GetComponent<DestroyableBehaviour>().DebrisPrefab.gameObject.transform.Find("chunks").gameObject);
            BrainMatter4.gameObject.transform.position = transform.position;
            BrainMatter4.gameObject.GetComponent<ParticleSystem>().startColor = new Color(0.6f, 0f, 0.2f, 1f);
            System.Random rand = new System.Random();
                            GameObject spine = GameObject.Instantiate(ModAPI.FindSpawnable("lintestineobject").Prefab);
                            CatalogBehaviour.PerformMod(ModAPI.FindSpawnable("lintestineobject"), spine);
                            spine.transform.position = transform.position;
                            if (transform.root.gameObject.GetComponent<PersonBehaviour>().Limbs[2].gameObject != null)
                            {
                                    HingeJoint2D hingeJoint = spine.AddComponent<HingeJoint2D>();
                                   hingeJoint.connectedBody = transform.root.gameObject.GetComponent<PersonBehaviour>().Limbs[2].gameObject.GetComponent<Rigidbody2D>();
                                   hingeJoint.anchor = new Vector3(0f, 0f);
                                   spine.transform.position = transform.position + Vector3.up * 0.1f;

                                   JointAngleLimits2D limits = hingeJoint.limits;
                                   limits.min = 700;
                                   limits.max = -700;
                                   hingeJoint.limits = limits;
                                   hingeJoint.useLimits = false;
                                foreach (var Limbs in transform.root.gameObject.GetComponent<PersonBehaviour>().Limbs)
                        {
                          var DontCollideWithUser = Limbs.gameObject.AddComponent<NoCollide>();
                          DontCollideWithUser.NoCollideSetA = spine.gameObject.transform.root.gameObject.GetComponentsInChildren<Collider2D>();
                          DontCollideWithUser.NoCollideSetB = Limbs.gameObject.GetComponentsInChildren<Collider2D>();
                        }
                            }
                            GameObject spin2e = GameObject.Instantiate(ModAPI.FindSpawnable("sintestineobject").Prefab);
                            CatalogBehaviour.PerformMod(ModAPI.FindSpawnable("sintestineobject"), spin2e);
                            spin2e.transform.position = transform.position;
        GameObject skullchunk = GameObject.Instantiate(ModAPI.FindSpawnable("Brick").Prefab);
            skullchunk.layer = 9;
            skullchunk.transform.localScale *= 1.2f;
                        skullchunk.transform.position = transform.position;
                            skullchunk.gameObject.GetComponent<SpriteRenderer>().sprite = Mod.mid1;
                            skullchunk.AddComponent<DebrisComponent>();
                        var number2 = rand.Next(2);
                        if (number2 == 1)
                        {
                            skullchunk.GetComponent<Rigidbody2D>().angularVelocity = UnityEngine.Random.value * 8f;
                        skullchunk.GetComponent<Rigidbody2D>().velocity = new Vector2(UnityEngine.Random.value * 8f, UnityEngine.Random.value * 8f); 
                        }
                        else
                        {
                            skullchunk.GetComponent<Rigidbody2D>().angularVelocity = -UnityEngine.Random.value * 8f;
                        skullchunk.GetComponent<Rigidbody2D>().velocity = new Vector2(-UnityEngine.Random.value * 8f, -UnityEngine.Random.value * 8f); 
                        }
                        skullchunk.gameObject.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
                        ModAPI.CreateParticleEffect("BloodExplosion", skullchunk.transform.position);
                        skullchunk.FixColliders();
                        foreach (var Limbs in transform.root.gameObject.GetComponent<PersonBehaviour>().Limbs)
                        {
                          var DontCollideWithUser = Limbs.gameObject.AddComponent<NoCollide>();
                          DontCollideWithUser.NoCollideSetA = skullchunk.gameObject.transform.root.gameObject.GetComponentsInChildren<Collider2D>();
                          DontCollideWithUser.NoCollideSetB = Limbs.gameObject.GetComponentsInChildren<Collider2D>();
                        }
                        GameObject skullcunk = GameObject.Instantiate(ModAPI.FindSpawnable("Brick").Prefab);
            skullcunk.layer = 9;
            skullcunk.transform.localScale *= 1.3f;
            skullcunk.AddComponent<DebrisComponent>();
                        skullcunk.transform.position = transform.position;
                            skullcunk.gameObject.GetComponent<SpriteRenderer>().sprite = Mod.mid2;
                        var numberf2 = rand.Next(2);
                        if (numberf2 == 1)
                        {
                            skullcunk.GetComponent<Rigidbody2D>().angularVelocity = UnityEngine.Random.value * 8f;
                        skullcunk.GetComponent<Rigidbody2D>().velocity = new Vector2(UnityEngine.Random.value * 8f, UnityEngine.Random.value * 8f); 
                        }
                        else
                        {
                            skullcunk.GetComponent<Rigidbody2D>().angularVelocity = -UnityEngine.Random.value * 8f;
                        skullcunk.GetComponent<Rigidbody2D>().velocity = new Vector2(-UnityEngine.Random.value * 8f, -UnityEngine.Random.value * 8f); 
                        }
                        skullcunk.gameObject.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
                        ModAPI.CreateParticleEffect("BloodExplosion", skullcunk.transform.position);
                        skullcunk.FixColliders();
                        foreach (var Limbs in transform.root.gameObject.GetComponent<PersonBehaviour>().Limbs)
                        {
                          var DontCollideWithUser = Limbs.gameObject.AddComponent<NoCollide>();
                          DontCollideWithUser.NoCollideSetA = skullchunk.gameObject.transform.root.gameObject.GetComponentsInChildren<Collider2D>();
                          DontCollideWithUser.NoCollideSetB = Limbs.gameObject.GetComponentsInChildren<Collider2D>();
                        }
                        GameObject skullcunk2 = GameObject.Instantiate(ModAPI.FindSpawnable("Brick").Prefab);
            skullcunk2.layer = 9;
            skullcunk2.AddComponent<DebrisComponent>();
            skullcunk2.transform.localScale *= 1.3f;
                        skullcunk2.transform.position = transform.position;
                            skullcunk2.gameObject.GetComponent<SpriteRenderer>().sprite = Mod.mid3;
                        var numbergf2 = rand.Next(2);
                        if (numbergf2 == 1)
                        {
                            skullcunk2.GetComponent<Rigidbody2D>().angularVelocity = UnityEngine.Random.value * 8f;
                        skullcunk2.GetComponent<Rigidbody2D>().velocity = new Vector2(UnityEngine.Random.value * 8f, UnityEngine.Random.value * 8f); 
                        }
                        else
                        {
                            skullcunk2.GetComponent<Rigidbody2D>().angularVelocity = -UnityEngine.Random.value * 8f;
                        skullcunk2.GetComponent<Rigidbody2D>().velocity = new Vector2(-UnityEngine.Random.value * 8f, -UnityEngine.Random.value * 8f); 
                        }
                        skullcunk2.gameObject.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
                        ModAPI.CreateParticleEffect("BloodExplosion", skullcunk2.transform.position);
                        skullcunk2.FixColliders();
                        foreach (var Limbs in transform.root.gameObject.GetComponent<PersonBehaviour>().Limbs)
                        {
                          var DontCollideWithUser = Limbs.gameObject.AddComponent<NoCollide>();
                          DontCollideWithUser.NoCollideSetA = skullcunk2.gameObject.transform.root.gameObject.GetComponentsInChildren<Collider2D>();
                          DontCollideWithUser.NoCollideSetB = Limbs.gameObject.GetComponentsInChildren<Collider2D>();
                        }
                        var DontCollideW2ithUser = skullcunk2.gameObject.AddComponent<NoCollide>();
                          DontCollideW2ithUser.NoCollideSetA = skullcunk.gameObject.transform.root.gameObject.GetComponentsInChildren<Collider2D>();
                          DontCollideW2ithUser.NoCollideSetB = skullcunk2.gameObject.GetComponentsInChildren<Collider2D>();
                          var DontCollideWi2thUser = skullcunk2.gameObject.AddComponent<NoCollide>();
                          DontCollideWi2thUser.NoCollideSetA = skullchunk.gameObject.transform.root.gameObject.GetComponentsInChildren<Collider2D>();
                          DontCollideWi2thUser.NoCollideSetB = skullcunk2.gameObject.GetComponentsInChildren<Collider2D>();
                          var DontColdlideWithUser = skullcunk.gameObject.AddComponent<NoCollide>();
                          DontColdlideWithUser.NoCollideSetA = skullchunk.gameObject.transform.root.gameObject.GetComponentsInChildren<Collider2D>();
                          DontColdlideWithUser.NoCollideSetB = skullcunk.gameObject.GetComponentsInChildren<Collider2D>();
                        GameObject skullchunk2 = GameObject.Instantiate(ModAPI.FindSpawnable("Brick").Prefab);
            skullchunk2.layer = 10;
            skullchunk2.AddComponent<DebrisComponent>();
            skullchunk2.transform.localScale *= 0.5f;
                        skullchunk2.transform.position = transform.position;
                        ModAPI.CreateParticleEffect("BloodExplosion", skullchunk2.transform.position);
                            skullchunk2.gameObject.GetComponent<SpriteRenderer>().sprite = Mod.skull3;
                        var number23 = rand.Next(2);
                        if (number23 == 1)
                        {
                            skullchunk2.GetComponent<Rigidbody2D>().angularVelocity = UnityEngine.Random.value * 8f;
                        skullchunk2.GetComponent<Rigidbody2D>().velocity = new Vector2(UnityEngine.Random.value * 8f, UnityEngine.Random.value * 8f); 
                        }
                        else
                        {
                            skullchunk2.GetComponent<Rigidbody2D>().angularVelocity = -UnityEngine.Random.value * 8f;
                        skullchunk2.GetComponent<Rigidbody2D>().velocity = new Vector2(-UnityEngine.Random.value * 8f, -UnityEngine.Random.value * 8f); 
                        }
                        skullchunk2.gameObject.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
                        skullchunk2.FixColliders();
                        GameObject skullchunk3 = GameObject.Instantiate(ModAPI.FindSpawnable("Brick").Prefab);
            skullchunk3.layer = 10;
            skullchunk3.AddComponent<DebrisComponent>();
            skullchunk3.transform.localScale *= 0.5f;
            ModAPI.CreateParticleEffect("BloodExplosion", skullchunk3.transform.position);
                        skullchunk3.transform.position = transform.position;
                            skullchunk3.gameObject.GetComponent<SpriteRenderer>().sprite = Mod.skull3;
                        var number223 = rand.Next(2);
                        if (number223 == 1)
                        {
                            skullchunk3.GetComponent<Rigidbody2D>().angularVelocity = UnityEngine.Random.value * 8f;
                        skullchunk3.GetComponent<Rigidbody2D>().velocity = new Vector2(UnityEngine.Random.value * 8f, UnityEngine.Random.value * 8f); 
                        }
                        else
                        {
                            skullchunk3.GetComponent<Rigidbody2D>().angularVelocity = -UnityEngine.Random.value * 8f;
                        skullchunk3.GetComponent<Rigidbody2D>().velocity = new Vector2(-UnityEngine.Random.value * 8f, -UnityEngine.Random.value * 8f); 
                        }
                        skullchunk3.gameObject.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
                        skullchunk3.FixColliders();
                        skullchunk3.gameObject.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
                        skullchunk3.FixColliders();
                        GameObject skullchunk4 = GameObject.Instantiate(ModAPI.FindSpawnable("Brick").Prefab);
            skullchunk4.layer = 10;
            skullchunk4.AddComponent<DebrisComponent>();
            ModAPI.CreateParticleEffect("BloodExplosion", skullchunk4.transform.position);
            skullchunk4.transform.localScale *= 0.4f;
                        skullchunk4.transform.position = transform.position;
                            skullchunk4.gameObject.GetComponent<SpriteRenderer>().sprite = Mod.skull3;
                        var number2223 = rand.Next(2);
                        if (number2223 == 1)
                        {
                            skullchunk4.GetComponent<Rigidbody2D>().angularVelocity = UnityEngine.Random.value * 8f;
                        skullchunk4.GetComponent<Rigidbody2D>().velocity = new Vector2(UnityEngine.Random.value * 8f, UnityEngine.Random.value * 8f); 
                        }
                        else
                        {
                            skullchunk4.GetComponent<Rigidbody2D>().angularVelocity = -UnityEngine.Random.value * 8f;
                        skullchunk4.GetComponent<Rigidbody2D>().velocity = new Vector2(-UnityEngine.Random.value * 8f, -UnityEngine.Random.value * 8f); 
                        }
                        skullchunk4.gameObject.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
                        skullchunk4.FixColliders();
                ModAPI.CreateParticleEffect("BloodExplosion", transform.position);
                ModAPI.CreateParticleEffect("BloodExplosion", transform.position);
                ModAPI.CreateParticleEffect("BloodExplosion", transform.position);
                CameraShakeBehaviour.main.Shake(2f * 6f, transform.position);
                        gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
        }

        public void Update()
        {
            if (!Ejected)
            {
            if (gameObject.GetComponent<SkinMaterialHandler>().currentDamagePointCount > 12 && gameObject.GetComponent<LimbBehaviour>().Health == 0 || gameObject.GetComponent<SkinMaterialHandler>().currentDamagePointCount > 12 && gameObject.GetComponent<LimbBehaviour>().Health < 0)
            {
                Ejected = true;
                Splat();
            }
            }
        }
    }
    public class OtherSplatter : MonoBehaviour
    {
        public bool Ejected = false;

        public void Splat()
        {
            GameObject BrainMatter = GameObject.Instantiate(ModAPI.FindSpawnable("Pumpkin").Prefab.GetComponent<DestroyableBehaviour>().DebrisPrefab.gameObject.transform.Find("chunks").gameObject);
            BrainMatter.gameObject.transform.position = transform.position;
            BrainMatter.gameObject.GetComponent<ParticleSystem>().startColor = new Color(0.5f, 0.2f, 0.2f, 1f); 
            GameObject BrainMatter4 = GameObject.Instantiate(ModAPI.FindSpawnable("Pumpkin").Prefab.GetComponent<DestroyableBehaviour>().DebrisPrefab.gameObject.transform.Find("chunks").gameObject);
            BrainMatter4.gameObject.transform.position = transform.position;
            BrainMatter4.gameObject.GetComponent<ParticleSystem>().startColor = new Color(0.6f, 0f, 0.2f, 1f);
            System.Random rand = new System.Random();
        GameObject skullchunk = GameObject.Instantiate(ModAPI.FindSpawnable("Brick").Prefab);
            skullchunk.layer = 9;
            skullchunk.transform.localScale *= 1.2f;
                        skullchunk.transform.position = transform.position;
                            skullchunk.gameObject.GetComponent<SpriteRenderer>().sprite = Mod.frag1;
                            skullchunk.AddComponent<DebrisComponent>();
                        var number2 = rand.Next(2);
                        if (number2 == 1)
                        {
                            skullchunk.GetComponent<Rigidbody2D>().angularVelocity = UnityEngine.Random.value * 8f;
                        skullchunk.GetComponent<Rigidbody2D>().velocity = new Vector2(UnityEngine.Random.value * 8f, UnityEngine.Random.value * 8f); 
                        }
                        else
                        {
                            skullchunk.GetComponent<Rigidbody2D>().angularVelocity = -UnityEngine.Random.value * 8f;
                        skullchunk.GetComponent<Rigidbody2D>().velocity = new Vector2(-UnityEngine.Random.value * 8f, -UnityEngine.Random.value * 8f); 
                        }
                        skullchunk.gameObject.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
                        ModAPI.CreateParticleEffect("BloodExplosion", skullchunk.transform.position);
                        skullchunk.FixColliders();
                        foreach (var Limbs in transform.root.gameObject.GetComponent<PersonBehaviour>().Limbs)
                        {
                          var DontCollideWithUser = Limbs.gameObject.AddComponent<NoCollide>();
                          DontCollideWithUser.NoCollideSetA = skullchunk.gameObject.transform.root.gameObject.GetComponentsInChildren<Collider2D>();
                          DontCollideWithUser.NoCollideSetB = Limbs.gameObject.GetComponentsInChildren<Collider2D>();
                        }
                        GameObject skullcunk = GameObject.Instantiate(ModAPI.FindSpawnable("Brick").Prefab);
            skullcunk.layer = 9;
            skullcunk.transform.localScale *= 1.3f;
            skullcunk.AddComponent<DebrisComponent>();
                        skullcunk.transform.position = transform.position;
                            skullcunk.gameObject.GetComponent<SpriteRenderer>().sprite = Mod.frag2;
                        var numberf2 = rand.Next(2);
                        if (numberf2 == 1)
                        {
                            skullcunk.GetComponent<Rigidbody2D>().angularVelocity = UnityEngine.Random.value * 8f;
                        skullcunk.GetComponent<Rigidbody2D>().velocity = new Vector2(UnityEngine.Random.value * 8f, UnityEngine.Random.value * 8f); 
                        }
                        else
                        {
                            skullcunk.GetComponent<Rigidbody2D>().angularVelocity = -UnityEngine.Random.value * 8f;
                        skullcunk.GetComponent<Rigidbody2D>().velocity = new Vector2(-UnityEngine.Random.value * 8f, -UnityEngine.Random.value * 8f); 
                        }
                        skullcunk.gameObject.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
                        ModAPI.CreateParticleEffect("BloodExplosion", skullcunk.transform.position);
                        skullcunk.FixColliders();
                        foreach (var Limbs in transform.root.gameObject.GetComponent<PersonBehaviour>().Limbs)
                        {
                          var DontCollideWithUser = Limbs.gameObject.AddComponent<NoCollide>();
                          DontCollideWithUser.NoCollideSetA = skullchunk.gameObject.transform.root.gameObject.GetComponentsInChildren<Collider2D>();
                          DontCollideWithUser.NoCollideSetB = Limbs.gameObject.GetComponentsInChildren<Collider2D>();
                        }
                        GameObject skullcunk2 = GameObject.Instantiate(ModAPI.FindSpawnable("Brick").Prefab);
            skullcunk2.layer = 9;
            skullcunk2.AddComponent<DebrisComponent>();
            skullcunk2.transform.localScale *= 1.3f;
                        skullcunk2.transform.position = transform.position;
                            skullcunk2.gameObject.GetComponent<SpriteRenderer>().sprite = Mod.frag3;
                        var numbergf2 = rand.Next(2);
                        if (numbergf2 == 1)
                        {
                            skullcunk2.GetComponent<Rigidbody2D>().angularVelocity = UnityEngine.Random.value * 8f;
                        skullcunk2.GetComponent<Rigidbody2D>().velocity = new Vector2(UnityEngine.Random.value * 8f, UnityEngine.Random.value * 8f); 
                        }
                        else
                        {
                            skullcunk2.GetComponent<Rigidbody2D>().angularVelocity = -UnityEngine.Random.value * 8f;
                        skullcunk2.GetComponent<Rigidbody2D>().velocity = new Vector2(-UnityEngine.Random.value * 8f, -UnityEngine.Random.value * 8f); 
                        }
                        skullcunk2.gameObject.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
                        ModAPI.CreateParticleEffect("BloodExplosion", skullcunk2.transform.position);
                        skullcunk2.FixColliders();
                        foreach (var Limbs in transform.root.gameObject.GetComponent<PersonBehaviour>().Limbs)
                        {
                          var DontCollideWithUser = Limbs.gameObject.AddComponent<NoCollide>();
                          DontCollideWithUser.NoCollideSetA = skullcunk2.gameObject.transform.root.gameObject.GetComponentsInChildren<Collider2D>();
                          DontCollideWithUser.NoCollideSetB = Limbs.gameObject.GetComponentsInChildren<Collider2D>();
                        }
                        var DontCollideW2ithUser = skullcunk2.gameObject.AddComponent<NoCollide>();
                          DontCollideW2ithUser.NoCollideSetA = skullcunk.gameObject.transform.root.gameObject.GetComponentsInChildren<Collider2D>();
                          DontCollideW2ithUser.NoCollideSetB = skullcunk2.gameObject.GetComponentsInChildren<Collider2D>();
                          var DontCollideWi2thUser = skullcunk2.gameObject.AddComponent<NoCollide>();
                          DontCollideWi2thUser.NoCollideSetA = skullchunk.gameObject.transform.root.gameObject.GetComponentsInChildren<Collider2D>();
                          DontCollideWi2thUser.NoCollideSetB = skullcunk2.gameObject.GetComponentsInChildren<Collider2D>();
                          var DontColdlideWithUser = skullcunk.gameObject.AddComponent<NoCollide>();
                          DontColdlideWithUser.NoCollideSetA = skullchunk.gameObject.transform.root.gameObject.GetComponentsInChildren<Collider2D>();
                          DontColdlideWithUser.NoCollideSetB = skullcunk.gameObject.GetComponentsInChildren<Collider2D>();
                        GameObject skullchunk2 = GameObject.Instantiate(ModAPI.FindSpawnable("Brick").Prefab);
            skullchunk2.layer = 10;
            skullchunk2.AddComponent<DebrisComponent>();
            skullchunk2.transform.localScale *= 0.5f;
                        skullchunk2.transform.position = transform.position;
                        ModAPI.CreateParticleEffect("BloodExplosion", skullchunk2.transform.position);
                            skullchunk2.gameObject.GetComponent<SpriteRenderer>().sprite = Mod.skull3;
                        var number23 = rand.Next(2);
                        if (number23 == 1)
                        {
                            skullchunk2.GetComponent<Rigidbody2D>().angularVelocity = UnityEngine.Random.value * 8f;
                        skullchunk2.GetComponent<Rigidbody2D>().velocity = new Vector2(UnityEngine.Random.value * 8f, UnityEngine.Random.value * 8f); 
                        }
                        else
                        {
                            skullchunk2.GetComponent<Rigidbody2D>().angularVelocity = -UnityEngine.Random.value * 8f;
                        skullchunk2.GetComponent<Rigidbody2D>().velocity = new Vector2(-UnityEngine.Random.value * 8f, -UnityEngine.Random.value * 8f); 
                        }
                        skullchunk2.gameObject.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
                        skullchunk2.FixColliders();
                        GameObject skullchunk3 = GameObject.Instantiate(ModAPI.FindSpawnable("Brick").Prefab);
            skullchunk3.layer = 10;
            skullchunk3.AddComponent<DebrisComponent>();
            skullchunk3.transform.localScale *= 0.5f;
            ModAPI.CreateParticleEffect("BloodExplosion", skullchunk3.transform.position);
                        skullchunk3.transform.position = transform.position;
                            skullchunk3.gameObject.GetComponent<SpriteRenderer>().sprite = Mod.skull3;
                        var number223 = rand.Next(2);
                        if (number223 == 1)
                        {
                            skullchunk3.GetComponent<Rigidbody2D>().angularVelocity = UnityEngine.Random.value * 8f;
                        skullchunk3.GetComponent<Rigidbody2D>().velocity = new Vector2(UnityEngine.Random.value * 8f, UnityEngine.Random.value * 8f); 
                        }
                        else
                        {
                            skullchunk3.GetComponent<Rigidbody2D>().angularVelocity = -UnityEngine.Random.value * 8f;
                        skullchunk3.GetComponent<Rigidbody2D>().velocity = new Vector2(-UnityEngine.Random.value * 8f, -UnityEngine.Random.value * 8f); 
                        }
                        skullchunk3.gameObject.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
                        skullchunk3.FixColliders();
                        skullchunk3.gameObject.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
                        skullchunk3.FixColliders();
                        GameObject skullchunk4 = GameObject.Instantiate(ModAPI.FindSpawnable("Brick").Prefab);
            skullchunk4.layer = 10;
            skullchunk4.AddComponent<DebrisComponent>();
            ModAPI.CreateParticleEffect("BloodExplosion", skullchunk4.transform.position);
            skullchunk4.transform.localScale *= 0.4f;
                        skullchunk4.transform.position = transform.position;
                            skullchunk4.gameObject.GetComponent<SpriteRenderer>().sprite = Mod.skull3;
                        var number2223 = rand.Next(2);
                        if (number2223 == 1)
                        {
                            skullchunk4.GetComponent<Rigidbody2D>().angularVelocity = UnityEngine.Random.value * 8f;
                        skullchunk4.GetComponent<Rigidbody2D>().velocity = new Vector2(UnityEngine.Random.value * 8f, UnityEngine.Random.value * 8f); 
                        }
                        else
                        {
                            skullchunk4.GetComponent<Rigidbody2D>().angularVelocity = -UnityEngine.Random.value * 8f;
                        skullchunk4.GetComponent<Rigidbody2D>().velocity = new Vector2(-UnityEngine.Random.value * 8f, -UnityEngine.Random.value * 8f); 
                        }
                        skullchunk4.gameObject.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
                        skullchunk4.FixColliders();
                ModAPI.CreateParticleEffect("BloodExplosion", transform.position);
                ModAPI.CreateParticleEffect("BloodExplosion", transform.position);
                ModAPI.CreateParticleEffect("BloodExplosion", transform.position);
                CameraShakeBehaviour.main.Shake(2f * 6f, transform.position);
                        gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
        }

        public void Update()
        {
            if (!Ejected)
            {
            if (gameObject.GetComponent<SkinMaterialHandler>().currentDamagePointCount > 12 && gameObject.GetComponent<LimbBehaviour>().Health == 0 || gameObject.GetComponent<SkinMaterialHandler>().currentDamagePointCount > 12 && gameObject.GetComponent<LimbBehaviour>().Health < 0)
            {
                Ejected = true;
                Splat();
            }
            }
        }
    }
    public class Heart : MonoBehaviour
    {
        public AudioSource audioSource;
        public AudioClip beat = Mod.beat;
        public int repeat = 23;
        public float Length = 0.008f;

        public void Start()
        {
            audioSource = new GameObject().gameObject.AddComponent<AudioSource>();
    audioSource.transform.SetParent(transform, false);
    GameObject.FindObjectOfType<Global>().AddAudioSource(audioSource,false);
    audioSource.gameObject.AddComponent<AudioDistortionFilter>().distortionLevel = 0.75f;
    audioSource.outputAudioMixerGroup = GameObject.FindObjectOfType<Global>().SoundEffects;
    audioSource.spatialBlend = 1;
    audioSource.volume = 1;
    StartCoroutine(die());
        }

        IEnumerator die()
        {
          for (int i = 0; i < repeat; i++)
        {
            audioSource.PlayOneShot(beat);
            yield return new WaitForSeconds(Length);
            transform.localScale *= 1.3f;
            ModAPI.CreateParticleEffect("BloodExplosion", transform.position);
            yield return new WaitForSeconds(Length);
            Length += 0.03f;
            transform.localScale /= 1.3f;
        }
        }
    }
}